##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette

#PALETTE= 13  0 1 2 3 6 9 11  12   15 16 18 20 24 25  26
PALETTE =  13 0 4 24 6 1 15 16 18 20 14 25  26 3 5 

$(eval $(call IMG2SP, SET_FOLDER      , src/sprites              ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))          
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), palette ))


$(eval $(call IMG2SP, CONVERT         , assets/bullet.png , 8, 5,bullet,))
$(eval $(call IMG2SP, CONVERT         , assets/bullet_enemy.png , 8, 5,bullet_enemy,))
$(eval $(call IMG2SP, CONVERT         , assets/bullet_flip.png , 8, 5,bullet_flip,))
$(eval $(call IMG2SP, CONVERT         , assets/bullet_enemy_flip.png , 8, 5,bullet_enemy_flip,))
$(eval $(call IMG2SP, CONVERT         , assets/pj.png , 12, 21,pj))
$(eval $(call IMG2SP, CONVERT         , assets/chicago30Boss.png , 14, 21,chicago30Boss))
$(eval $(call IMG2SP, CONVERT         , assets/chicago30Boss_flip.png , 14, 21,chicago30Boss_flip))
$(eval $(call IMG2SP, CONVERT         , assets/enemigoChicagos30.png , 14, 21,enemigoChicagos30))
$(eval $(call IMG2SP, CONVERT         , assets/enemigoChicagos30_flip.png , 14, 21,enemigoChicagos30_flip))

$(eval $(call IMG2SP, CONVERT         , assets/normalf.png , 12, 21,pjf,))
$(eval $(call IMG2SP, CONVERT         , assets/pj_crouched.png , 12, 16,pj_crouched,))
$(eval $(call IMG2SP, CONVERT         , assets/running.png , 12, 21,pj_running,))
$(eval $(call IMG2SP, CONVERT         , assets/running2.png , 12, 21,pj_running2,))
$(eval $(call IMG2SP, CONVERT         , assets/shooting.png , 12, 21,pj_shooting,))
$(eval $(call IMG2SP, CONVERT         , assets/sword_attack.png , 12, 21,pj_swattack,))
$(eval $(call IMG2SP, CONVERT         , assets/sword_still.png , 12, 21,pj_swstill,))
$(eval $(call IMG2SP, CONVERT         , assets/sword_stillf.png , 12, 21,pj_swstillf,))
$(eval $(call IMG2SP, CONVERT         , assets/sword_running2.png , 12, 21,pj_swrunning2,))
$(eval $(call IMG2SP, CONVERT         , assets/sword_running.png , 12, 21,pj_swrunning,))


$(eval $(call IMG2SP, CONVERT         , assets/closed_door.png , 16, 23,closed_door))
$(eval $(call IMG2SP, CONVERT         , assets/open_door.png , 16, 23,open_door))

$(eval $(call IMG2SP, CONVERT         , assets/enemy.png , 16, 21,enemy,))
$(eval $(call IMG2SP, CONVERT         , assets/enemy_flip.png , 16, 21,enemy_flip,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b.png , 8, 5,back_b,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b2.png , 8, 5,back_b2,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b3.png , 8, 5,back_b3,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b4.png , 8, 5,back_b4,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b5.png , 8, 5,back_b5,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b6.png , 8, 5,back_b6,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b7.png , 8, 5,back_b7,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b8.png , 8, 5,back_b8,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b9.png , 8, 5,back_b9,))
$(eval $(call IMG2SP, CONVERT         , assets/back_b1.png , 8, 5,back_b1,))



$(eval $(call IMG2SP, CONVERT         , assets/full_heart.png , 12,10,full_heart,))
$(eval $(call IMG2SP, CONVERT         , assets/empty_heart.png , 12,10,empty_heart,))
$(eval $(call IMG2SP, CONVERT         , assets/full_bullet.png , 4,6,full_bullet,))
$(eval $(call IMG2SP, CONVERT         , assets/empty_bullet.png , 4,6,empty_bullet,))

$(eval $(call IMG2SP, CONVERT         , assets/shield.png , 12,10,shield,))
$(eval $(call IMG2SP, CONVERT         , assets/bulletBox.png , 12,10,bullet_box,))
$(eval $(call IMG2SP, CONVERT         , assets/shield_no.png , 12,10,shield_no,))
$(eval $(call IMG2SP, CONVERT         , assets/empty.png , 12,10,empty,))

$(eval $(call IMG2SP, CONVERT         , assets/rightWall.png , 4, 4,rightWall,))
$(eval $(call IMG2SP, CONVERT         , assets/leftWall.png , 4, 4,leftWall,))
$(eval $(call IMG2SP, CONVERT         , assets/middleWall.png , 8, 4,middleWall,))
$(eval $(call IMG2SP, CONVERT         , assets/floor4.png , 4, 4,floor4,))
$(eval $(call IMG2SP, CONVERT         , assets/roof.png , 4, 4,roof,))
$(eval $(call IMG2SP, CONVERT         , assets/floor8.png , 4, 8,floor8,))
$(eval $(call IMG2SP, CONVERT         , assets/floor8not.png , 4, 8,floor8not,))
 

$(eval $(call IMG2SP, SET_OUTPUT      , bin                ))

$(eval $(call IMG2SP, CONVERT         , assets/screens/menu1.png ,80 ,200,menu1,))
$(eval $(call IMG2SP, CONVERT         , assets/screens/menu2.png ,80 ,200,menu2,))

$(eval $(call IMG2SP, CONVERT         , assets/screens/input1.png ,80 ,75,input1,))
$(eval $(call IMG2SP, CONVERT         , assets/screens/input2.png ,80 ,75,input2,))

$(eval $(call IMG2SP, CONVERT         , assets/screens/pause1.png ,60 ,43,pause1,))
$(eval $(call IMG2SP, CONVERT         , assets/screens/pause2.png ,60 ,43,pause2,))

$(eval $(call IMG2SP, CONVERT         , assets/screens/you_died1.png ,80 ,200,you_died1,))
$(eval $(call IMG2SP, CONVERT         , assets/screens/you_died2.png ,80 ,200,you_died2,))


$(eval $(call IMG2SP, CONVERT         , assets/screens/you_win1.png ,76 ,68,you_win1,))
$(eval $(call IMG2SP, CONVERT         , assets/screens/you_win2.png ,76 ,68,you_win2,))


$(eval $(call IMG2SP, CONVERT         , assets/screens/controls1.png ,80 ,69,controls1,))
$(eval $(call IMG2SP, CONVERT         , assets/screens/controls2.png ,80 ,69,controls2,))

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

#PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,assets/sprite.png,0,pre,8,8,$(PALETTE),,src/sprites/,hwpalette))
#$(eval $(call IMG2SPRITES,assets/sprite_crouched.png,0,g,8,5,$(PALETTE),,src/sprites/,hwpalette))




############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
