;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

m_front_buffer: .db 0xC0
m_back_buffer: .db 0x80 
.include "buffer.h.s"
.include "utils.h.s"
.include "levels.h.s"
.include "hero.h.s"
.include "entity.h.s"

.area _g_masktable_ (ABS)
.org 0x1F80
_g_masktable::
     .db 0xFF, 0xAA, 0x55, 0x00, 0xAA, 0xAA, 0x00, 0x00 
      .db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0xAA, 0xAA, 0x00, 0x00, 0xAA, 0xAA, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0xAA, 0xAA, 0x00, 0x00, 0xAA, 0xAA, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0xAA, 0xAA, 0x00, 0x00, 0xAA, 0xAA, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
      .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00


.area _CSEG (REL, CON)
ret


;;===========================
;;
;;===========================
newScene:

  call cpct_waitVSYNC_asm
  call switchBuffers

  halt
  halt
  halt
  halt
  halt
  halt


  ret
;;===========================
;; Intercambiamos los buffers
;; Destruidos: AF, BC, HL
;;===========================
clearBuffer::
	ld a, (m_back_buffer)
	ld h, a 
	ld de, #0 
	ld l , e
	ld bc, #0x4000
	call cpct_memset_f64_asm
	ret	
;;===========================
;; Intercambiamos los buffers
;; Destruidos: AF, BC, HL
;;===========================
switchBuffers:
	ld a, (m_back_buffer)
	ld b, a 
	ld a, (m_front_buffer)
	ld (m_back_buffer), a  
	ld a, b 
	ld (m_front_buffer), a 

	srl b 
	srl b 
	ld l, b
	jp cpct_setVideoMemoryPage_asm

render_draw:
  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0
  ld    b, h_y(ix)                 ;; B = y coordinate (24 = 0x18)
  ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)
  call cpct_getScreenPtr_asm  
   ex    de,   hl

   ld b, h_sp_h(ix)
   ld c, h_sp_l(ix)
    ld h, h_h(ix)
    ld l, h_w(ix)
   push ix 

   ld    a,    l
   .dw 0x6FDD     
   ld    a,    h
   .dw 0x67DD


  ld hl, #_g_masktable
   call cpct_drawSpriteMaskedAlignedTable_asm     ;; Dibujar Cubo

   pop ix

   ret


flip_sprite::
	ld    b,    h_h(ix)       
	ld    c,    h_w(ix)              ;; Cargar alto en B y ancho en C
	ld h, h_sp_h(ix)
	ld l, h_sp_l(ix)
	call cpct_hflipSpriteM0_asm      ;; Dibujar Cubo  
	ret

change_sprite::
  ld h_sp_l(ix), l 
  ld h_sp_h(ix), h 
  ret
