;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "bullet.h.s"
.include "cpctelera.h.s"
.include "utils.h.s"
.include "enemy.h.s"
.include "levels.h.s"
.include "hero.h.s"
.include "entity.h.s"
.include "buffer.h.s"

.include "menu.h.s"
;;============================== 
;; BULLET VECTOR DATA
;;=============================
k_max_num_bullet = 10
k_bullet_size = 13
entity_bullet:
DefineNBullets entity_bullet, k_max_num_bullet
DefineBullet bulletLeft, 11, 160, 4, 5,_bullet_flip, move_bulletLeft, 1, 0, 0, 0x0000
DefineBullet bulletRight, 11, 160, 4, 5,_bullet, move_bulletRight , 0, 0, 0, 0x0000

k_puntero_size = 5

helper: .dw 0x0000

;; 0-1 = Background sprite, 2 = x, 3 = y, 4 = ocupied?
back_puntero_b1:  .dw #_back_b
                  .db #0, #0, #0
back_puntero_b2:  .dw #_back_b2
                  .db #0, #0, #0
back_puntero_b3:  .dw #_back_b3
                  .db #0, #0, #0
back_puntero_b4:  .dw #_back_b4
                  .db #0, #0, #0                  
back_puntero_b5:  .dw #_back_b5
                  .db #0, #0, #0
back_puntero_b6:  .dw #_back_b6
                  .db #0, #0, #0
back_puntero_b7:  .dw #_back_b7
                  .db #0, #0, #0
back_puntero_b8:  .dw #_back_b8
                  .db #0, #0, #0
back_puntero_b9:  .dw #_back_b9
                  .db #0, #0, #0
back_puntero_b10:  .dw #_back_b1
                  .db #0, #0, #0

m_num_bullet: .db 00
m_next_bullet: .dw entity_bullet
shoot_status: .db #-1       ;; 0 = Just crouched (Activate Cooldown) / 1 = Free to crouch
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; METHODS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


save_background_bullet:

  push iy
  push hl

  ld h, b_back_h(ix)
  ld l, b_back_l(ix)

  push hl
  pop iy
  
  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0x00

  ld    b, h_y(ix)                 ;; B = y coordinate (24 = 0x18)
  ld    3(iy), b

  ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)
  ld    2(iy), c


  call cpct_getScreenPtr_asm

  ld d, 1(iy)
  ld e, 0(iy)

  ld    c, h_w(ix)

  ld    b, h_h(ix)

  call cpct_getScreenToSprite_asm

  pop hl
  pop iy

ret

draw_back_ground_bullet_front:


  ld h, b_back_h(ix)
  ld l, b_back_l(ix)

  push hl
  pop iy

  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0x00
  ld    b, 3(iy)                 ;; B = y coordinate (24 = 0x18)
  ld    c, 2(iy)                  ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  

  ex de, hl

  ld h, 1(iy)
  ld l, 0(iy)

  ld c, h_w(ix)
  ld b, h_h(ix)

  call cpct_drawSprite_asm

  
ret

draw_back_ground_bullet:


  ld h, b_back_h(ix)
  ld l, b_back_l(ix)

  push hl
  pop iy

  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0x00
  ld    b, 3(iy)                 ;; B = y coordinate (24 = 0x18)
  ld    c, 2(iy)                  ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  

  ex de, hl

  ld h, 1(iy)
  ld l, 0(iy)

  ld c, h_w(ix)
  ld b, h_h(ix)

  call cpct_drawSprite_asm

  
ret

choose_background:
  
  push iy

  ld a, #10
  ld iy, #back_puntero_b1

  punteros_loop:

  push af

  ld a, 4(iy)
  cp #0
  jr nz, next_bullet_pointer

    ld a, #1
    ld 4(iy), a

    pop af
    push iy
    pop hl

    ld b_back_l(ix), l
    ld b_back_h(ix), h

    push hl
    pop iy

    pop iy

    ret

  next_bullet_pointer:

  pop af

  ld bc, #k_puntero_size
  add iy, bc
  dec a

  jp nz, punteros_loop

  pop iy

ret



restart_bullets:

  ld  a, #0
  ld (m_num_bullet), a
  ld  hl, #entity_bullet
  ld (m_next_bullet), hl

  push ix
  ld ix, #back_puntero_b1
  ld a, #10

  loop_restart_bullets:

  push af

    ld a, #0
    ld 4(ix), a

    pop af

    ld bc, #k_puntero_size
    add ix, bc
    dec a

  jp nz, loop_restart_bullets

  pop ix


  ret
;;================================
;; Modifies the bullet's exit
;; IN: B -> TYPE BULLET
;; DESTROYS: AF, IY-> bullet, IX-> entity, BC
;;===============================
modify_bullet:
  ld a, h_dir(ix) ;; Entity's direction
  cp #0 ;If it's 0, its looking left
  jr z, left_bullet 
  ;; Otherwise
  ld iy, #bulletRight 
  ld a, h_x(ix) ;;We add entity's x and weight
  add h_w(ix)
  add #2
  jp change_values

  left_bullet: 
  ld iy, #bulletLeft
  ld a, h_x(ix)
  sub h_w(iy)
  sub #2

  change_values: ;;Modify the values of the bullet(x, y)
  ld b_type(iy), b ;; Type of bullet: 1 enemy, 0 hero
  push af
  ld a, b
  cp #0
  jr z, heroBullet

  ld a, h_dir(ix) ;; Entity's direction
  cp #0 ;If it's 0, its looking left
  jr z, left_bullet_enemy
  ld hl, #_bullet_enemy 
  ld h_sp_h(iy), h 
  ld h_sp_l(iy), l
  jr continue

  left_bullet_enemy:

  ld hl, #_bullet_enemy_flip 
  ld h_sp_h(iy), h 
  ld h_sp_l(iy), l
  jr continue
  
  heroBullet:
  ld a, h_dir(ix) ;; Entity's direction
  cp #0 ;If it's 0, its looking left
  jr z, left_bullet_hero
  ld hl, #_bullet 
  ld h_sp_h(iy), h 
  ld h_sp_l(iy), l

  jr continue
  left_bullet_hero:

    ld hl, #_bullet_flip 
  ld h_sp_h(iy), h 
  ld h_sp_l(iy), l

  continue:
  pop af
  ld h_x(iy), a 
  ld a, h_y(ix)
  ld h_y(iy), a
  .dw #0x44FD ;ld b, iyh
  .dw #0x4DFD ;ld c, iyl
  ld h, b 
  ld l, c
  ld a, (current_view)
  ld h_vw(iy),a
  
ret  

;;================================
;; Draws bullet on screen
;; DESTROYS: AF, BC, DE
;;===============================
draw_bullet:
  ld a, b_dir(ix)
  cp #0
  jr z, dont_change
  dont_change:
   call render_draw
   ret
;;================================
;;  Moves bullet at the right
;; DESTROYS: IX, AF
;;===============================
move_bulletRight:
  call save_background_bullet
  call ent_moveRight
  ld a, h_x(ix)
  cp #80-4
  ret m
    call delete_ent
  ret
;;================================
;; Moves bullet at the left
;; DESTROYS: IX, AF
;;===============================
move_bulletLeft:
  call save_background_bullet
  call ent_moveLeft
  ld a, h_x(ix)
  cp #00
  ret p
    call delete_ent
  ret
;;================================
;; Updates bullet
;; DESTROYS: IX, HL
;;===============================
update_bullet:
  ld h, b_up_h(ix)
  ld l, b_up_l(ix)
  jp (hl)
  ret
  
clearBullets:
  ld hl, #draw_back_ground_bullet
  call bullet_doForAll
ret

;;================================
;; Creates a new bullet
;; DESTROYS: HL, BC, AF
;;================================
new_bullet:
  ld a, (m_num_bullet) 
  inc a
  ld (m_num_bullet), a

  ld hl, (m_next_bullet)
  ld bc, #k_bullet_size
  add hl, bc 
  ld (m_next_bullet), hl 
  or a 
  sbc hl, bc
  ret
;;================================
;; Copies the bullet values
;; DESTROYS: BC, HL, DE
;;================================
copy_bullet:
  ld bc, #k_bullet_size
  ldir 
  ret

;;================================
;; Updates bullet
;; DESTROYS: IX, HL
;;================================
update_bullets:

  ld hl, #update_bullet 
  call bullet_doForAll

ret

draw_bullets:

  ld hl, #draw_bullet 
  call bullet_doForAll

ret

;;================================
;; Iterates over the bullet's vector and calls a method
;; DESTROYS: AF, IX, HL
;; IN: IY-> OTHER ENTITIES
;;================================
bullet_doForAll::
  ld a, (m_num_bullet)
  cp #0
  jr z,no_hacer_nada
  ld ix, #entity_bullet
  ld (method), hl

buc:
  push  af
  ld a, (current_view)
  sub h_vw(ix)
  jr nz, here
  method = . + 1
  call  method
  here:
  pop af
  ld  bc, #k_bullet_size      ;;|
  add   ix,   bc              ;;\ Adds entity's size to the pointer
  dec   a
  jr    nz,   buc
  no_hacer_nada:
  ret


;;================================
;; CHecks how many bullets our hero has
;; DESTROYS:  AF, IX
;;================================
check_ammo:
 ld ix, #hero
 ld a, h_bull(ix) ;;loads ammo into a
 cp #0
 jr z, do_nothing
 ld b, #0
 call shoot_bullet  ;;if we have >=1 bullet we can shoot
 ld a, h_bull(ix)
 dec a 
 ld h_bull(ix),a
       call draw_hud
      call switchBuffers
      call draw_hud
      call switchBuffers
 ld  hl,   #shootHero_status
 ld  (hl),  #0
 do_nothing:
 ret

;;================================
;; Shoots a bullet on the map
;; DESTROYS:  30B7HL, AF, DE
;; IN: B -> TYPE BULLET
;;================================
shoot_bullet:
    ld b, #k_max_num_bullet
    ld a, (m_num_bullet)
    sub b
    ret z
    push ix
    ld a, (shootHero_status) ;;If it's 0, we can't shoot
    cp #0
    jr  z,  acabar
     call new_bullet ;;Otherwise we create the bullet
     ex de, hl 

     ld b, #0
     call modify_bullet

     push hl
     push de
     pop hl

     ld (helper), hl

     push hl
     pop de
     pop hl

     call copy_bullet

     ld hl, (helper)
     push hl
     pop ix

     call choose_background

     call save_background_bullet


     ld  hl,   #shoot_status ;;Activates the cooldown
     ld  (hl),  #0

    acabar:
    pop ix
  ret

enemy_shoot_bullet:
  ld b, #k_max_num_bullet
  ld a, (m_num_bullet)
  sub b
  ret z

  ld a, e_sst(ix);;If it's 0, we can't shoot
    cp #0
    jr  z,  enemy_acabar
     call new_bullet ;;Otherwise we create the bullet
     ex de, hl 
     ld b, #1
     call modify_bullet

     push ix

     push hl
     push de
     pop hl

     ld (helper), hl

     push hl
     pop de
     pop hl
     call copy_bullet


     ld hl, (helper)
     push hl
     pop ix

     call choose_background

     call save_background_bullet

     pop ix

    ld  a,   #0
    ld  e_sst(ix),  a
    enemy_acabar:
  ret
;;================================
;; Controls the bullet's cooldown
;; DESTROYS: HL, AF
;;================================
bullet_control:
  ld  a,  (shoot_status)
  cp  #0
  ret   nz
      ld  a,  b_cd(ix)
      cp #0
      jr  z,  restart_shoot
      dec b_cd(ix)
      ret

  restart_shoot:
    ld  b_cd(ix), #20
    ld  hl,   #shoot_status
    ld  (hl),  #1
   ret

enemy_bullet_control:
  ld  a,  e_sst(ix)
  cp  #0
  ret   nz
      ld  a,  e_scd(ix)
      cp #0
      jr  z,  enemy_restart_shoot
      dec e_scd(ix)
      ret

  enemy_restart_shoot:
    ld  e_scd(ix), #30
    ld  a,   #1
    ld  e_sst(ix),  a
   ret


;;================================
;; Checks bullets collisions on the wall
;; DESTROYS: IX, HL
;;================================
check_bullets_collisions:
  ld hl, #check_a_collision
  ld iy, (wall_vector)
  ld a, (m_num_wall)
  call bullet_doForAll
  ret

;;================================
;; Checks bullets collisions on the hero
;; DESTROYS: IX, HL
;;================================
check_hero_collisions:
  ld hl, #check_collision_hero
  ld iy, #hero
  call bullet_doForAll
  ret

;;================================
;; Checks bullet collisions on the hero
;; if not collide return 0, otherwise 1
;; IN: IY -> HERO, IX -> BULLET
;; DESTROYS: A
;; OUTPUT: A
;;================================
check_collision_hero:
  ld    a,    h_x(iy)            ;; A = hero_x COLISIONA EN IZQUIERDA?
  add   h_w(iy)                  ;; A = hero_x + hero_w
  sub   h_x(ix)                  ;; A = hero_x + hero_w - bullet_x <= 0
    jp    m, no_collision

  ld    a,    h_x(ix)            ;; A = bullet_X COLISIONA EN DERECHA?
  add   h_w(ix)                  ;; A = bullet_x + bullet_w
  sub   h_x(iy)                  ;; A = bullet_x + bullet_w - hero_x <= 0
  jp    m, no_collision  

    ld    a,    h_y(iy)            ;; A = hero_y EJE Y
    add   h_h(iy)                  ;; A = hero_y + hero_h
    sub   h_y(ix)                  ;; A = hero_y + hero_y - bullet_y <= 0
    jp    m, no_collision

  ld    a,    h_y(ix)            ;; A = bullet_y
  add   h_h(ix)                  ;; A = bullet_y + bullet_h
  sub   h_y(iy)                  ;; A = bullet_y + bullet_h - hero_y <= 0
  jp    m, no_collision 

  collision:
    call check_accessories
    jr finalizee
       no_collision: 
        finalizee:

  ret


end_of_game::
  call clearBuffer
  call show_dead
  ; call esperar
  repeat:
  call cpct_scanKeyboard_asm          ;; Scan Keyboard
  ld hl, #Key_N
  call cpct_isKeyPressed_asm          ;; Check if D was pressed
  jp    z, N_not_pressed    
  call newScene

  ;; se resetea al primer nivel
  call restart_enemies
  call reset_hero
  call restart_bullets
  call restart_levels
  call restart_enemies      
  jp beggining
  ret

  N_not_pressed:
  ld hl, #Key_Y
  call cpct_isKeyPressed_asm          ;; Check if D was pressed
  jp    z, Y_not_pressed   

  call newScene
  call reset_hero
  call restart_bullets
  call restart_actual_level 
  jp init_all

  Y_not_pressed:
  jp repeat
  ret
;;=============================
;; CHECK IF HAS A SHIELD AND REFLECT BULLET
;; DESTROYS: A, HL
;; IN: IX -> BULLET, IY -> HERO  
;;============================= 
check_accessories:
  ld a, h_shld(iy) ;; If he has shield, bullet doesn't hurt
  cp #0 
  jr nz, reflect_bullet

  call delete_ent     ;; If bullet isnt' going to be reflected, delete it.
  ld a, (hearts_remaining)
  dec a
  ld (hearts_remaining), a
   jr z, end_of_game

  call draw_hud
  call switchBuffers
  call draw_hud
  call switchBuffers

  jp finish

  reflect_bullet:
  ld a, b_dir(ix)
  cp #0 
  jr z, reflect_to_left 
  ld hl, #move_bulletRight
  push hl
  ld a, h_x(iy)
  add h_w(iy)
  add #2
  ld h_x(ix), a
  ld hl, #_bullet_enemy
  ld h_sp_h(ix), h 
  ld h_sp_l(ix), l

  jp change 
  reflect_to_left:
  ld hl, #move_bulletLeft
  push hl
  ld a, h_x(iy)
  sub h_w(ix)
  sub #2
  ld h_x(ix), a
  ld hl, #_bullet_enemy_flip 
  ld h_sp_h(ix), h 
  ld h_sp_l(ix), l

  change:
  pop hl
  ld b_up_l(ix), l
  ld b_up_h(ix), h
  ld b_type(ix), #0 ;; now is type hero

  ld a, h_shld(iy)  ;;Shield has been used, so decrement it
  dec a 
  ld h_shld(iy), a

  call draw_hud
  call switchBuffers
  call draw_hud
  call switchBuffers

  finish:
 ret 



;;=============================
;; Checks bullets collisions on the check_enemies_collisions
;; DESTROYS: HL, IY, AF
;;============================= 
check_enemies_collisions:
  ld hl, #check_enemy_collision
  ld iy, (enemy_vector)
  call bullet_doForAll
  ret

;;================================
;; DESTROYS: IX, HL
;;================================
check_a_collision:
  ld a, (m_num_wall)
  cp #0
  jr z, finalize_all
  ld iy, (wall_vector)

  loopeo:
   push af
   
   ld a, h_vw(ix)
   cp h_vw(iy)
   jr nz, no_colision
   ld a, h_x(ix)
   cp #75
   jr z, colision

   ld a, h_x(ix)
   cp #0 
   jr z, colision 
   ld    a,    h_x(iy)            ;; A = obstacle_X COLISIONA EN IZQUIERDA?
   add   h_w(iy)                  ;; A = obstacle_x + obstacke_w
   sub   h_x(ix)                  ;; A = obstacle_x + obstacle_w - bullet_x <= 0
    jp    m, no_colision

   ld    a,    h_x(ix)            ;; A = bullet_X COLISIONA EN DERECHA?
   add   h_w(ix)                  ;; A = bulleto_x + obstacke_w
   sub   h_x(iy)                  ;; A = bullet_x + bullet_w - obstacle_x <= 0
   jp    m, no_colision  

    ld    a,    h_y(iy)            ;; A = obstacle_y EJE Y
   add   h_h(iy)                  ;; A = obstacle_y + obstacke_h
   sub   h_y(ix)                  ;; A = obstacle__y+ obstacle__h - bullet_y <= 0
    jp    m, no_colision

   ld    a,    h_y(ix)            ;; A = bulletyejey
   add   h_h(ix)                  ;; A = bullet_y + obstacle_h
   sub   h_y(iy)                  ;; A = bullet_y + bullet_h- obstacle_y <= 0
   jp    m, no_colision 


   colision:

    call delete_ent
    pop af
    ld a, #1
    ret
  
   no_colision: 
   pop af
   dec a 
   cp #0
   jr z, finalize_all
   ld bc, #k_wall_size
   add iy, bc
   jp loopeo
   finalize_all:
   ld a, #0
   ret

;;================================
;; Deletes an entity and clears it on the screen
;; DESTROYS: IX, HL, AF, BC, DE
;;=============================switchBuffers===
delete_ent::
  borrar_todo:

  call switchBuffers
  call draw_back_ground_bullet
  call switchBuffers


    push iy

    ld h, b_back_h(ix)
    ld l, b_back_l(ix)

    push hl
    pop iy

    ld a, #0
    ld 4(iy), a

    pop iy

    ld bc, #k_bullet_size ;;9
    ld hl, (m_next_bullet) ;; 1,2,3-->
    or a ;;Carry
    sbc hl, bc ;;Estamos en 1,2,--->3 
    ld (m_next_bullet), hl
    push ix ;;cWe push it in order to not to lose it
    ld ix, (m_next_bullet)

    pop ix ;; Recuperamos nuestra entidad a borrar

    ld bc, #k_bullet_size 
    .dw 0x54DD ;; ld d,ixh
    .dw 0x5DDD ;; ld e, ixl
    ld hl, (m_next_bullet) 
    ;; We need DE the position were we going to put the last object on HL
    call copy_bullet

   substract_entity:
    ld a, (m_num_bullet) ;;We have 1 object less
    dec a 
    ld (m_num_bullet), a 
  ret
