;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "bullet.h.s"
.include "entity.h.s"
.include "hero.h.s"
.include "cpctelera.h.s"
.include "utils.h.s"
.include "enemy.h.s"
.include "levels.h.s"
.include "buffer.h.s"
.globl _enemy

;; #############################
;; # ENEMIES
;; #############################


k_enemy_size = 27

m_num_enemy_01: .db #0
m_num_enemy_02: .db #1
m_num_enemy_03: .db #1
m_num_enemy_04: .db #1
m_num_enemy_05: .db #1
m_num_enemy_1: .db #2
m_num_enemy_2: .db #4
m_num_enemy_3: .db #4  
m_num_enemy_4: .db #4  
m_num_enemy_5: .db #4  
m_num_enemy_6: .db #4  
m_num_enemy_7: .db #4  
m_num_enemy_8: .db #7  
m_num_enemy_9: .db #7  
m_num_enemy_10: .db #6
m_num_enemy_11: .db #6
m_num_enemy_12: .db #6  
m_num_enemy_13: .db #9  
m_num_enemy_14: .db #9  
m_num_enemy_15: .db #12  

;; DefineEnemy _name, _x, _y, _w, _h, _sp, _upd, _dir, _vx, _xi, _xf, _yi, _yf, _isUp, _dvr, _dvl, _health, _vw, _ovw, _ohealth

enemies_level_01:

enemies_level_02:
DefineEnemy type_enemy_1_02, 3, 125, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 71, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 3, 125

enemies_level_03:
DefineEnemy type_enemy_1_03, 3, 125, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 31, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 3, 125

enemies_level_04:
DefineEnemy type_enemy_1_04, 3, 75, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 71, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 3, 75

enemies_level_05:
DefineEnemy type_enemy_1_05, 3, 75, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 29, 25, 25, 0, 1, 0, 0, 1, 30, -1, 0, 0, 3, 75

enemies_level_1:
DefineEnemy type_enemy_1_1, 3, 25, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 73, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 3, 25
DefineEnemy type_enemy_2_1, 66, 175, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot,  0, 0x01, 38, 71, 175, 175, 0, 1, 1, 1, 1, 30, -1, 0, 0, 65, 175

enemies_level_2:
DefineEnemy type_enemy_1_2, 30, 175, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 72, 175, 175, 0, 1, 0, 0, 1, 30, -1,   0, 0, 30, 175
DefineEnemy type_enemy_2_2, 30, 75, 6, 21, _enemy, enemy_move_pattern_2, normal_shoot, 0, 0x01, 3, 72, 75, 75, 0, 1, 0, 0, 1, 30, -1,   0, 0, 30, 75
DefineEnemy type_enemy_3_2, 30, 175, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 71, 175, 175, 0, 1, 1, 1, 1, 30, -1,  0, 0, 30, 175
DefineEnemy type_enemy_4_2, 30, 75, 6, 21, _enemy, enemy_move_pattern_2, normal_shoot, 0, 0x01, 3, 71, 75, 75, 0, 1, 1, 1, 1, 30, -1,   0, 0, 30, 75

enemies_level_3:
DefineEnemy type_enemy_1_3, 10, 25, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 33, 25, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_2_3, 10, 125, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 3, 72, 125, 125, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 125
DefineEnemy type_enemy_3_3, 50, 25, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 46, 73, 25, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 25
DefineEnemy type_enemy_4_3, 60, 175, 6, 21, _enemy, enemy_move_pattern_1, normal_shoot, 0, 0x01, 2, 71, 77, 77, 0, 1, 1, 1, 1, 30, -1,  0, 0, 60, 175

enemies_level_4:
DefineEnemy type_enemy_1_4, 10, 25, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, normal_shoot, 0, 0x01, 5, 69, 25, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_2_4, 20, 125, 6, 21, _enemy_flip, enemy_move_pattern_2, normal_shoot, 0, 0x01, 3, 29, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 20, 125
DefineEnemy type_enemy_3_4, 10, 25, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, normal_shoot, 0, 0x01, 5, 69, 25, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_4_4, 60, 125, 6, 21, _enemy, enemy_move_pattern_2, normal_shoot, 0, 0x01, 46, 71, 25, 125, 0, 1, 1, 1, 1, 30, -1,  0, 0, 60, 125

enemies_level_5:
DefineEnemy type_enemy_1_5, 5, 25, 6, 21, _enemy, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 5, 73, 25, 175, 0, 1, 0, 0, 1, 30, -1,  0, 0, 5, 25
DefineEnemy type_enemy_2_5, 50, 125, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 47, 73, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 125
DefineEnemy type_enemy_3_5, 20, 175, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 71, 175, 175, 0, 1, 1, 1, 1, 30, -1,  0, 0, 20, 175
DefineEnemy type_enemy_4_5, 50, 125, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, alternate_shoot_up, 0, 0x01, 3, 69, 75, 125, 0, 1, 1, 1, 1, 30, -1,  0, 0, 50, 125

enemies_level_6:
DefineEnemy type_enemy_1_6, 50, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 72, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 75
DefineEnemy type_enemy_2_6, 50, 125, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, alternate_shoot_up, 0, 0x01, 48, 69, 125, 175, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 125
DefineEnemy type_enemy_3_6, 60, 25, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, alternate_shoot_up, 0, 0x01, 46, 69, 25, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 60, 25
DefineEnemy type_enemy_4_6, 50, 175, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 71, 175, 175, 0, 1, 1, 1, 1, 30, -1,  0, 0, 50, 175

enemies_level_7:
DefineEnemy type_enemy_1_7, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 35, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_2_7, 50, 125, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, alternate_shoot_up, 0, 0x01, 3, 69, 75, 175, 0, 1, 0, 0, 1, 30, -1, 0, 0, 50, 125
DefineEnemy type_enemy_3_7, 60, 125, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 39, 70, 125, 125, 0, 1, 1, 1, 1, 30, -1,  0, 0, 60, 125
DefineEnemy type_enemy_4_7, 70, 25, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_static, alternate_shoot_up, 0, 0x01, 3, 74, 25, 25, 0, 1, 1, 1, 1, 30, -1,  0, 0, 70, 25

enemies_level_8:
DefineEnemy type_enemy_1_8, 10, 25, 6, 21, _enemy, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 35, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_2_8, 30, 75, 6, 21, _enemy, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 35, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 30, 75
DefineEnemy type_enemy_3_8, 40, 125, 7, 21, _enemigoChicagos30, enemy_move_pattern_static, alternate_shoot_up, 1, 0x01, 42, 80, 125, 125, 0, 1, 0, 0, 1, 30, 0, 0, 0, 40, 125
DefineEnemy type_enemy_4_8, 3, 25, 6, 21, _enemy, enemy_move_pattern_1, alternate_shoot_up, 0, 0x01, 3, 70, 25, 25, 0, 1, 1, 1, 1, 30, -1, 0, 0, 3, 25
DefineEnemy type_enemy_5_8, 3, 75, 6, 21, _enemy, enemy_move_pattern_1, alternate_shoot_up, 0, 0x01, 3, 32, 25, 25, 0, 1, 1, 1, 1, 30, -1, 0, 0, 3, 75
DefineEnemy type_enemy_6_8, 20, 125, 6, 21, _enemy, enemy_move_pattern_1, alternate_shoot_up, 0, 0x01, 3, 70, 125, 125, 0, 1, 1, 1, 1, 30, -1,  0, 0, 20, 125
DefineEnemy type_enemy_7_8, 65, 175, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 45, 70, 25, 25, 0, 1, 1, 1, 1, 30, -1,  0, 0, 65, 175

enemies_level_9:
DefineEnemy type_enemy_1_9, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 72, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_2_9, 50, 125, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 72, 125, 125, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 125
DefineEnemy type_enemy_3_9, 25, 75, 6, 21, _enemy, enemy_move_pattern_static, alternate_shoot_up, 1, 0x01, 26, 78, 80, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 26, 75
DefineEnemy type_enemy_5_9, 10, 75, 6, 21, _enemy, enemy_move_pattern_1, alternate_shoot_up, 0, 0x01, 3, 69, 75, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 10, 75
DefineEnemy type_enemy_6_9, 65, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, alternate_shoot_up, 0, 0x01, 3, 69, 25, 25, 0, 1, 1, 1, 1, 30, -1,  0, 0, 65, 25
DefineEnemy type_enemy_7_9, 10, 125, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, alternate_shoot_up, 0, 0x01, 3, 30, 125, 175, 0, 1, 1, 1, 1, 30, -1,  0, 0, 10, 125
DefineEnemy type_enemy_8_9, 65, 175, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_3_left_up, alternate_shoot_up, 0, 0x01, 46, 69, 125, 175, 0, 1, 1, 1, 1, 30, -1,  0, 0, 65, 175

enemies_level_10:
DefineEnemy type_enemy_1_10, 60, 125, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, two_shoots, 0, 0x01, 3, 69, 125, 175, 0,  1, 0, 0, 1, 30, -1, 0, 0, 60, 125
DefineEnemy type_enemy_2_10, 50, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 39, 72, 25, 125, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 75
DefineEnemy type_enemy_3_10, 10, 25, 6, 21, _enemy, enemy_move_pattern_static, two_shoots, 1, 0x01, 26, 80, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_4_10, 70, 25, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_static, two_shoots, 0, 0x01, 3, 70, 75, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 70, 25
DefineEnemy type_enemy_5_10, 34, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 36, 75, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 34, 75
DefineEnemy type_enemy_6_10, 10, 175, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, two_shoots, 0, 0x01, 3, 69, 125, 175, 0, 1, 1, 1, 1, 30, -1, 0, 0, 10, 175

enemies_level_11:
DefineEnemy type_enemy_1_11, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 50, 125, 125, 0, 1, 0, 0, 1, 30, -1, 0, 0, 10, 25
DefineEnemy type_enemy_2_11, 45, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 43, 72, 25, 125, 0, 1, 0, 0, 1, 30, -1,  0, 0, 45, 75
DefineEnemy type_enemy_3_11, 60, 125, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 1, 0x01, 3, 70, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 60, 125
DefineEnemy type_enemy_4_11, 70, 125, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_static, two_shoots, 0, 0x01, 3, 70, 75, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 70, 125
DefineEnemy type_enemy_5_11, 5, 175, 7, 21, _enemigoChicagos30, enemy_move_pattern_static, two_shoots, 1, 0x01, 11, 80, 75, 75, 0, 1, 1, 1, 1, 30, -1, 0, 0, 5, 175
DefineEnemy type_enemy_6_11, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 72, 25, 25, 0, 1, 1, 1, 1, 30, -1,  0, 0, 10, 25

enemies_level_12:
DefineEnemy type_enemy_1_12, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 72, 25, 25, 0, 1, 0, 0, 1, 30, -1, 0, 0, 10, 25
DefineEnemy type_enemy_2_12, 70, 75, 6, 21, _enemy_flip, enemy_move_pattern_static, two_shoots, 0, 0x01, 3, 70, 125, 125, 0, 1, 0, 0, 1, 30, -1, 0, 0, 70, 75
DefineEnemy type_enemy_3_12, 60, 125, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_3_right_up, two_shoots, 1, 0x01, 3, 69, 125, 175, 0, 1, 0, 0, 1, 30, -1,  0, 0, 60, 125
DefineEnemy type_enemy_4_12, 5, 75, 7, 21, _enemigoChicagos30, enemy_move_pattern_static, two_shoots, 1, 0x01, 5, 80, 75, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 5, 75
DefineEnemy type_enemy_5_12, 60, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 72, 25, 25, 0, 1, 1, 1, 1, 30, -1,  0, 0, 60, 25
DefineEnemy type_enemy_7_12, 65, 175, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_3_left_up, two_shoots, 0, 0x01, 3, 69, 125, 175, 0, 1, 1, 1, 1, 30, -1, 0, 0, 65, 175

enemies_level_13:
DefineEnemy type_enemy_1_13, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 29, 125, 125, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_2_13, 10, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 29, 25, 125, 0, 1, 0, 0, 1, 30, -1,   0, 0, 10, 75
DefineEnemy type_enemy_3_13, 50, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 43, 70, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 25
DefineEnemy type_enemy_4_13, 50, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 43, 70, 25, 125, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 75
DefineEnemy type_enemy_5_13, 60, 125, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 1, 0x02, 4, 72, 75, 75, 0, 1, 0, 0, 1, 30, -1,   0, 0, 60, 125
DefineEnemy type_enemy_6_13, 34, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 1, 0x02, 4, 70, 75, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 34, 75
DefineEnemy type_enemy_7_13, 60, 125, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_static, two_shoots, 0, 0x01, 3, 60, 75, 125, 0, 1, 1, 1, 1, 30, -1, 0, 0, 60, 125
DefineEnemy type_enemy_8_13, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 30, 25, 25, 0, 1, 1, 1, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_9_13, 60, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 43, 70, 25, 25, 0, 1, 1, 1, 1, 30, -1,   0, 0, 60, 25

enemies_level_14:
DefineEnemy type_enemy_1_14, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 35, 125, 125, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_2_14, 10, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 29, 75, 75, 0, 1, 0, 0, 1, 30, -1,   0, 0, 10, 75
DefineEnemy type_enemy_3_14, 50, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 1, 0x01, 44, 70, 75, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 50, 75
DefineEnemy type_enemy_4_14, 50, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 41, 70, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 75
DefineEnemy type_enemy_5_14, 60, 125, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 1, 0x02, 4, 72, 75, 75, 0, 1, 0, 0, 1, 30, -1, 0, 0, 60, 125
DefineEnemy type_enemy_6_14, 20, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 1, 0x01, 3, 30, 75, 75, 0, 1, 1, 1, 1, 30, -1,   0, 0, 20, 75
DefineEnemy type_enemy_7_14, 60, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x02, 4, 70, 75, 125, 0, 1, 1, 1, 1, 30, -1,   0, 0, 60, 25
DefineEnemy type_enemy_8_14, 47, 175, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_static, two_shoots, 0, 0x01, 3, 70, 75, 175, 0, 1, 1, 1, 1, 30, -1,  0, 0, 47, 175
DefineEnemy type_enemy_9_14, 70, 125, 7, 21, _enemigoChicagos30_flip, enemy_move_pattern_static, two_shoots, 0, 0x01, 3, 70, 75, 175, 0, 1, 1, 1, 1, 30, -1,  0, 0, 60, 125

enemies_level_15:
DefineEnemy type_enemy_1_15, 10, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 29, 25, 25, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 25
DefineEnemy type_enemy_2_15, 10, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 29, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 10, 75
DefineEnemy type_enemy_3_15, 50, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 43, 70, 75, 75, 0, 1, 0, 0, 1, 30, -1,  0, 0, 50, 75
DefineEnemy type_enemy_11_15, 50, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 43, 70, 25, 25, 0, 1, 0, 0, 1, 30, -1,   0, 0, 50, 25
DefineEnemy type_enemy_4_15, 60, 125, 7, 21, _enemigoChicagos30, enemy_move_pattern_3_right_up, two_shoots, 1, 0x02, 4, 68, 125, 175, 0, 1, 0, 0, 1, 30, -1,   0, 0, 60, 125
DefineEnemy type_enemy_5_15, 50, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 1, 0x01, 43, 70, 75, 75, 0, 1, 1, 1, 1, 30, -1,  0, 0, 50, 75
DefineEnemy type_enemy_6_15, 20, 75, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 1, 0x01, 3, 29, 75, 75, 0, 1, 1, 1, 1, 30, -1,   0, 0, 20, 75
DefineEnemy type_enemy_7_15, 60, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 43, 70, 75, 125, 0, 1, 1, 1, 1, 30, -1,  0, 0, 60, 25
DefineEnemy type_enemy_8_15, 20, 25, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x01, 3, 29, 75, 175, 0, 1, 1, 1, 1, 30, -1,   0, 0, 20, 25
DefineEnemy type_enemy_9_15, 60, 125, 6, 21, _enemy_flip, enemy_move_pattern_2, two_shoots, 0, 0x02, 4, 72, 125, 125, 0, 1, 1, 1, 1, 30, -1,   0, 0, 60, 125
DefineEnemy boss, 60, 25, 7, 21, _chicago30Boss, enemy_move_pattern_4_right_up, two_shoots, 0, 0x03, 3, 69, 25, 175, 0, 10, 2, 2, 10, 30, -1,  0, 0, 60, 25
DefineEnemy boss2, 42, 125, 7, 21, _chicago30Boss, enemy_move_pattern_4_left_up, two_shoots, 0, 0x03, 3, 69, 25, 175, 0, 10, 2, 2, 10, 30, -1,  0, 0, 42, 125

m_num_enemy: .db #0
actual_enemy: .dw #m_num_enemy_01        ;; m_num_enemy_01

enemy_vector:: .dw #enemies_level_01

m_num_levels:: .db #20       ;; 20
current_enemies: .db #0

clearEnemies:
  ld hl, #draw_back_ground_enemy
  ld    a,  (m_num_enemy)                    ;; Load in A the number of the Floors
  ld    bc,  (enemy_vector)              ;; Load in BC pointer to the Floors vector
  ld de, #k_enemy_size
  call  hero_doForAll
ret

save_background_enemy:

  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0x00

  ld    b, h_y(ix)                 ;; B = y coordinate (24 = 0x18)
  ld    e_py(ix), b

  ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)
  ld    e_px(ix), c

ret

draw_enemy_back_ground:
	
  ld d, a
  ld e, #0x00
  ld    b, e_py(ix)                 ;; B = y coordinate (24 = 0x18)
  ld 	a, e_px(ix)
  sub #1
  ld    c, a                        ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  

  ex de, hl

  ld a, h_w(ix)
  add #2
  ld c, a
  ld b, h_h(ix)

  ld a, #0x00

  call cpct_drawSolidBox_asm

ret

draw_back_ground_enemy_front:
  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  call draw_enemy_back_ground

ret

draw_back_ground_enemy:

  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  call draw_enemy_back_ground

ret

next_level_enemies::
  ld hl, (actual_enemy)
  ld a,   (hl)
  ld hl, (enemy_vector) 
  ld bc, #k_enemy_size

  buc_enemy_next:
    cp #0
    jr z, enemy_done

    add hl, bc
    dec a

    jr buc_enemy_next 

  enemy_done:
    ld  (enemy_vector), hl
    ld  hl, (actual_enemy)
    ld  bc, #0x0001
    add hl, bc
    ld  a, (hl)
    ld  (m_num_enemy), a
    ld  (current_enemies), a
    ld  (actual_enemy), hl

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INICIALIZA LOS ENEMIGOS PARA CADA NIVEL
;; REGISTROS DESTRUIDOS: HL, DE
;; ENTRADA: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
restart_enemies::
  ld a, #0
  ld (m_num_enemy), a
  ld hl, #m_num_enemy_01
  ld (actual_enemy), hl
  ld hl, #enemies_level_01
  ld (enemy_vector), hl

  ld  a, (m_num_levels)
  ld  e, a

  restart_enemies_levels:

  ld  a, (m_num_enemy)
  ld  ix, (enemy_vector)
  cp #0
  jr z, call_next_level_enemies

  restart_buc_enemies:

    ld d, e_ovw(ix)
    ld h_vw(ix), d
    ld d, e_ohealth(ix)
    ld e_health(ix), d

    ld d, e_ox(ix)
    ld h_x(ix), d
    ld d, e_oy(ix)
    ld h_y(ix), d

    ld  bc, #k_enemy_size      ;;|
    add   ix,   bc             ;;\ Sumar al puntero el tamaño de la entidad
    dec   a
    jr    nz,   restart_buc_enemies

    call_next_level_enemies:
    
    call next_level_enemies

    dec e
    jr  nz, restart_enemies_levels

      ld a, #0
      ld (m_num_enemy), a
      ld (current_enemies), a
      ld hl, #enemies_level_01
      ld (enemy_vector), hl
      ld hl, #m_num_enemy_01
      ld (actual_enemy), hl

  ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MODIFICA UN ENEMIGO
;; REGISTROS DESTRUIDOS:
;; ENTRADA: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
update_enemy:

    call save_background_enemy

    ld h,   b_up_h(ix)
    ld l,   b_up_l(ix)
    ld (metodo_enemigo), hl
    metodo_enemigo = . + 1
    call metodo_enemigo

  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJA UN ENEMIGO
;; REGISTROS DESTRUIDOS:
;; ENTRADA: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
draw_enemy:
	call render_draw

  ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; REALIZA UNA LLAMADA PARA TODOS LOS ENEMIGOS
;; REGISTROS DESTRUIDOS: A, BC
;; ENTRADA: HL -> METODO A REALIZAR
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_doForAll::
  push ix
  ld a, (m_num_enemy)
  cp #0
  jr z, no_hacer_nada
  ld ix, (enemy_vector)
  ld (llamada), hl

  buc:
  push  af

  ld  a, (current_view)
  sub h_vw(ix)
  jr nz, here

  
  llamada = . + 1
  call  llamada
here:
  pop af
  ld  bc, #k_enemy_size      ;;|
  add   ix,   bc              ;;\ Sumar al puntero el tamaño de la entidad
  dec   a
  jr    nz,   buc
  no_hacer_nada:
  pop ix
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ACTUALIZA LOS ENEMIGOS 
;; REGISTROS DESTRUIDOS: A, HL
;; ENTRADA: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
update_enemies::
  ld a,   (m_num_enemy)
  cp #0
  ret z

  ld hl, #update_enemy
  ld    a,  (m_num_enemy)                    ;; Load in A the number of the Floors
  ld    bc,  (enemy_vector)              ;; Load in BC pointer to the Floors vector
  ld de, #k_enemy_size
  call  hero_doForAll
  
ret

draw_enemies:
  ld a,   (m_num_enemy)
  cp #0
  ret z

  ld hl, #draw_enemy
  ld    a,  (m_num_enemy)                    ;; Load in A the number of the Floors
  ld    bc,  (enemy_vector)              ;; Load in BC pointer to the Floors vector
  ld de, #k_enemy_size
  call  hero_doForAll

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; BORRA UN ENEMIGO CUANDO ES ATACADO POR EL PERSONAJE
;; REGISTROS DESTRUIDOS: BC, HL, IY, A
;; ENTRADA: IY -> PUNTERO DEL ENEMIGO A BORRAR
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_borrar::
  
  push ix
  push iy
  pop ix
  pop iy

  ld a, (current_enemies)
  dec a
  ld (current_enemies), a

  ld h_vw(ix), #-1

  call switchBuffers
  call draw_back_ground_enemy
  call save_background_enemy
  call draw_back_ground_enemy_front
  call switchBuffers


  push ix
  push iy
  pop ix
  pop iy

  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTED HERO
;; REGISTROS DESTRUIDOS: HL, A, B, C
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

detect_hero_control:
ld b, #0
call detect_hero      ;; detect hero devuelve 1 si el enemigo lo ha visto en su fila
  cp #0
  jr z, mover
    ld b, #1

    ld  h, e_shh(ix)
    ld  l, e_shl(ix)
    ld  (shoot), hl

    shoot = . + 1
    call shoot
    ld a, #-1

    ret

  mover:

    ld a, #0

ret

check_xf:
  ld    a, e_xf(ix)
  ld    b, a
  ld    a, h_x(ix)
  cp    b

ret

check_xi:

  ld    a, e_xi(ix)
  ld    b, a
  ld    a, h_x(ix)
  cp    b

ret

check_yf:
  ld    a, e_yf(ix)
  ld    b, a
  ld    a, h_y(ix)
  cp    b

ret

check_yi:

  ld    a, e_yi(ix)
  ld    b, a
  ld    a, h_y(ix)
  cp    b

ret

move_right:

    ld  a, h_x(ix)
    add   e_vx(ix)
    ld h_x(ix), a

ret

move_left:
    ld  a, h_x(ix)
    sub   e_vx(ix)
    ld h_x(ix), a

ret

enemy_move_pattern_static:
  call detect_hero_control
ret

enemy_move_pattern_1:

  ld h_dir(ix), #1
  ld hl, #_enemy
  call change_sprite

  call detect_hero_control
  cp #0
  ret nz

  call check_xf
  jr z, cambiar_pattern_1

    call move_right
    ret

  cambiar_pattern_1:

  ld  hl, #enemy_move_pattern_2
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret

enemy_move_pattern_2:

  ld h_dir(ix), #0
  ld hl, #_enemy_flip
  call change_sprite
  call detect_hero_control
  cp #0
  ret nz

  call check_xi
  jr z, cambiar_pattern_2

    call move_left

    ret

  cambiar_pattern_2:

  ld  hl, #enemy_move_pattern_1
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret

enemy_move_pattern_3_right_up:

  ld h_dir(ix), #1
  ld hl, #_enemigoChicagos30
  call change_sprite
  call detect_hero_control
  cp #0
  ret nz

  call check_xf
  jr z, cambiar_pattern_3_right_up

    call move_right

    ret

  cambiar_pattern_3_right_up:

  call check_yi
  jp z, cambiar_pattern_3_right_go_down

    ld a, h_y(ix)
    sub #50
    ld h_y(ix), a
    call check_collision_hero
    cp #0
    jp z, no_change_yi_right

      ld a, h_y(ix)
      add #50
      ld h_y(ix), a

      no_change_yi_right:
      ld  hl, #enemy_move_pattern_3_left_up
      ld  b_up_l(ix), l
      ld  b_up_h(ix), h

      ret 

  cambiar_pattern_3_right_go_down:

  ld  hl, #enemy_move_pattern_3_right_down
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret

enemy_move_pattern_3_left_up:
  ld h_dir(ix), #0
  ld hl, #_enemigoChicagos30_flip
  call change_sprite
  call detect_hero_control
  cp #0
  ret nz

  call check_xi
  jr z, cambiar_pattern_3_left_up

    call move_left

    ret

  cambiar_pattern_3_left_up:

  call check_yi
  jp z, cambiar_pattern_3_left_go_down

    ld a, h_y(ix)
    sub #50
    ld h_y(ix), a
    call check_collision_hero
    cp #0
    jp z, no_change_yi_left

      ld a, h_y(ix)
      add #50
      ld h_y(ix), a

      no_change_yi_left:
      ld  hl, #enemy_move_pattern_3_right_up
      ld  b_up_l(ix), l
      ld  b_up_h(ix), h

      ret 

  cambiar_pattern_3_left_go_down:

  ld  hl, #enemy_move_pattern_3_left_down
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret

enemy_move_pattern_3_right_down:
  ld h_dir(ix), #1
  ld hl, #_enemigoChicagos30
  call change_sprite
  call detect_hero_control
  cp #0
  ret nz

  call check_xf
  jr z, cambiar_pattern_3_right_down

    call move_right

    ret

  cambiar_pattern_3_right_down:

  call check_yf
  jp z, cambiar_pattern_3_right_go_up

    ld a, h_y(ix)
    add #50
    ld h_y(ix), a
    call check_collision_hero
    cp #0
    jp z, no_change_right_down

      ld a, h_y(ix)
      sub #50
      ld h_y(ix), a

      no_change_right_down:
      ld  hl, #enemy_move_pattern_3_left_down
      ld  b_up_l(ix), l
      ld  b_up_h(ix), h

      ret 

  cambiar_pattern_3_right_go_up:

  ld  hl, #enemy_move_pattern_3_right_up
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret


enemy_move_pattern_3_left_down:
  ld h_dir(ix), #0
  ld hl, #_enemigoChicagos30_flip
  call change_sprite
  call detect_hero_control
  cp #0
  ret nz

  call check_xi
  jr z, cambiar_pattern_3_left_down

    call move_left

    ret

  cambiar_pattern_3_left_down:

  call check_yf
  jp z, cambiar_pattern_3_left_go_up

    ld a, h_y(ix)
    add #50
    ld h_y(ix), a
    call check_collision_hero
    cp #0
    jp z, no_change_left_down

      ld a, h_y(ix)
      sub #50
      ld h_y(ix), a

      no_change_left_down:
      ld  hl, #enemy_move_pattern_3_right_down
      ld  b_up_l(ix), l
      ld  b_up_h(ix), h

      ret 

  cambiar_pattern_3_left_go_up:

  ld  hl, #enemy_move_pattern_3_left_up
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret

normal_shoot:
  call enemy_shoot_bullet
ret

rapid_shoot:

  ld  a, e_sst(ix)
  cp #0
  ret z
  
  call enemy_shoot_bullet
  ld  a, #15
  ld  e_scd(ix), a
ret

two_shoots:

  ld  a, e_sst(ix)
  cp #0
  ret z

  call enemy_shoot_bullet
  ld  a, h_y(ix)
  add #8
  ld  h_y(ix), a

  ld  a, #-1
  ld  e_sst(ix), a

  call enemy_shoot_bullet
  ld a, h_y(ix)
  sub #8
  ld  h_y(ix), a

ret

alternate_shoot_up:

  ld  a, e_sst(ix)
  cp #0
  ret z

  call normal_shoot

  ld hl, #alternate_shoot_down
  ld e_shh(ix), h
  ld e_shl(ix), l

ret

alternate_shoot_down:

  ld  a, e_sst(ix)
  cp #0
  ret z

  ld  a, h_y(ix)
  add #8
  ld  h_y(ix), a

  call enemy_shoot_bullet

  ld a, h_y(ix)
  sub #8
  ld  h_y(ix), a

  ld hl, #alternate_shoot_up
  ld e_shh(ix), h
  ld e_shl(ix), l

ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA AL PROTAGONISTA DEVUELVE 1 SI VE AL HEROE
;; REGISTROS DESTRUIDOS: A, B, C, D, E
;; ENTRADA: IX -> Puntero a entidad
;; SALIDA: A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

detect_hero::
  push ix
  ld ix, #hero

  ld  a, h_y(ix)
  add h_h(ix)
  ld  d, a
  ld  c, h_x(ix)
  pop ix

  ld  a, h_y(ix)
  add h_h(ix)
  sub d
  jr nz, no_detect_hero

    ld  a, h_dir(ix)
    cp #0
    jr  z, look_left

    ld d, e_xf(ix)
    call d_menor_que_c
    ld a, e
    cp #0
    jr z, no_detect_hero

      ld  d, h_x(ix)
      call d_menor_que_c
      ld a, e
      cp #0
      jr z, detectado
      ld a, b
      cp #0
      jr z, no_detect_hero
        ld h_dir(ix), #0
        ld hl, #_chicago30Boss_flip
        call change_sprite
        jr detectado

    look_left:
      ld d, e_xi(ix)
      call d_menor_que_c                     
      ld a, e
      cp #1
      jr z, no_detect_hero
        ld  d, h_x(ix)
        call d_menor_que_c
        ld a, e
        cp #1
        jr z, detectado
        ld a, b
        cp #0
        jr z, no_detect_hero
        ld h_dir(ix), #1
        ld hl, #_chicago30Boss
        call change_sprite

    detectado:
      ld  a, #-1
      ret 

  no_detect_hero:

    ld a, #0
  
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DEVUELVE 0 SI D ES MENOR QUE C Y 1 EN CASO CONTRARIO
;; REGISTROS DESTRUIDOS: A, D, B
;; ENTRADA: D, C
;; SALIDA: E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
d_menor_que_c:
  push bc
  ld b, c         ;; se guarda la posicion x del enemigo
  restar:
  ld a, d
  cp #0
  jr z, d_menor
  ld a, b
  cp #0
  jr z, c_menor
  dec d
  dec b
  jr restar

  d_menor:
  ld e, #0
  jr acabarE

  c_menor:
  ld e, #1

  acabarE:
  pop bc
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DETECTA SI EL ENEMIGO CHOCA CON EL HEROE AL BAJAR O SUBIR
;; REGISTROS DESTRUIDOS: IY
;; ENTRADA: IX -> Puntero a enemy, E -> y final del enemy
;; SALIDA: A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
check_collision_hero:

  ld iy,   #hero

   ld    a,    h_x(ix)                    ;; A = hero_X
   add   h_w(ix)                          ;; A = hero_x + hero_w
   sub   h_x(iy)                          ;; A = hero_x + hero_w - obstacle_x
   jp    m, no_collisionHero

   ld    a,    h_x(iy)                 ;; A = Obstacle_X
   add   h_w(iy)                       ;; A = Obstacle_x + Obstacle_w             
   sub   h_x(ix)                       ;; A = Obstacle_x + Obstacle_w - hero_x
   jp    m, no_collisionHero

   ld    a,    h_y(iy)              ;; A = Obstacle_y
   add   h_h(iy)                    ;; A = Obstacle_y + Obstacle_h             
   sub   h_y(ix)                    ;; A = Obstacle_y + Obstacle_y - hero_y
   jp    m, no_collisionHero

   ld    a,    h_y(ix)              ;; A = hero_y
   add   h_h(ix)                    ;; A = hero_y + hero_h
   sub   h_y(iy)                    ;; A = hero_y + hero_w - obstacle_y
   jp    m, no_collisionHero

  colisionHero:
  ld a, #1

  ret
  
  no_collisionHero:
    ld a, #0
  ret

check_enemy_col:

	ld a, (current_view)
    sub h_vw(iy)
    jr nz, no_collision_gen

    ld    a,    h_x(iy)            ;; A = enemy_X COLISIONA EN IZQUIERDA?
   	add   h_w(iy)                  ;; A = enemy_x + enemy_w
    sub   h_x(ix)                  ;; A = oenemy_x + enemy_w - bullet/sword_x <= 0

    jp    m, no_collision_gen

    ld    a,    h_x(ix)            ;; A = bullet/sword_X COLISIONA EN DERECHA?
    add   h_w(ix)                  ;; A = bullet/sword_x + bullet/sword_w
    sub   h_x(iy)                  ;; A = bullet/sword_x + bullet/sword_w - enemy_x <= 0

    jp    m, no_collision_gen  

    ld    a,    h_y(iy)            ;; A = enemy_y EJE Y
    add   h_h(iy)                  ;; A = enemy_y + enemy_h
    sub   h_y(ix)                  ;; A = enemy_y + enemy__h - bullet/sword_y <= 0

    jp    m, no_collision_gen

    ld    a,    h_y(ix)            ;; A = bullet/sword_y 
    add   h_h(ix)                  ;; A = bullet/sword_y + bullet/sword_h
    sub   h_y(iy)                  ;; A = bullet/sword_y + bullet/sword_h - enemy_y <= 0

    jp    m, no_collision_gen

   	ld a, #1

   	ret

   no_collision_gen:

   ld a, #0

ret

check_enemy_collision_sword:
  ld a, (m_num_enemy)
  cp #0
  jp z, finalizee_sword
  ld iy, (enemy_vector)
  en_loop_sword:
   push af

   call check_enemy_col
   cp #0
   jr z, no_collision_sword

    
    ld a, e_health(iy) ;; Checks enemy's life
    dec a 
    jr nz, substract_life_sword ;; If it's not 0, just susbtract
    jp kill_sword       ;;If not, deletes the enemy's entity

    substract_life_sword:
    
    ld e_health(iy), a
    pop af
    ret

    kill_sword:

     call enemy_borrar

    pop af
    ret
  
   no_collision_sword: 
   pop af
   dec a 
   cp #0
   jr z, finalizee_sword
   ld bc, #k_enemy_size
   add iy, bc
   jp en_loop_sword
   finalizee_sword:
   ld a, #0
   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COMPRUEBA  QUE LA BALA COLISIONA CON UN ENEMIGO
;; REGISTROS DESTRUIDOS: A, IY, BC
;; ENTRADA: IX -> LA BALA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
check_enemy_collision:
  ld a, (m_num_enemy)
  cp #0
  jp z, finalizee
  ld iy, (enemy_vector)
  en_loop:
   push af

   call check_enemy_col
   cp #0
   jr z, no_collision

    ld a, b_type(ix)
    cp #1
    jr z, no_collision
    
    ld a, e_health(iy) ;; Checks enemy's life
    dec a 
    jr nz, substract_life ;; If it's not 0, just susbtract
    jp kill       ;;If not, deletes the enemy's entity

    substract_life:
    
    ld e_health(iy), a
    jp delete_bullet

    kill:

     call enemy_borrar

    delete_bullet:
     call delete_ent

    pop af
    ret
  
   no_collision: 
   pop af
   dec a 
   cp #0
   jr z, finalizee
   ld bc, #k_enemy_size
   add iy, bc
   jp en_loop
   finalizee:
   ld a, #0
   ret

enemy_move_pattern_4_right_up:

  ld h_dir(ix), #1
  ld hl, #_chicago30Boss
  call change_sprite
  call detect_hero_control2
  cp #0
  ret nz

  call check_xf
  jr z, cambiar_pattern_4_right_up

    call move_right

    ret

cambiar_pattern_4_right_up:

  call check_yi
  jp z, cambiar_pattern_4_right_go_down

    ld a, h_y(ix)
    sub #50
    ld h_y(ix), a
    call check_collision_hero
    cp #0
    jp z, no_change_yi_right2

      ld a, h_y(ix)
      add #50
      ld h_y(ix), a

      no_change_yi_right2:

      ld hl, #_chicago30Boss_flip
      call change_sprite
      ld  hl, #enemy_move_pattern_4_left_up
      ld  b_up_l(ix), l
      ld  b_up_h(ix), h

      ret 

  cambiar_pattern_4_right_go_down:

  ld  hl, #enemy_move_pattern_4_right_down
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret

enemy_move_pattern_4_left_up:
  ld h_dir(ix), #0
  ld hl, #_chicago30Boss_flip
  call change_sprite
  call detect_hero_control2
  cp #0
  ret nz

  call check_xi
  jr z, cambiar_pattern_4_left_up

    call move_left

    ret

  cambiar_pattern_4_left_up:

  call check_yi
  jp z, cambiar_pattern_4_left_go_down

    ld a, h_y(ix)
    sub #50
    ld h_y(ix), a
    call check_collision_hero
    cp #0
    jp z, no_change_yi_left2

      ld a, h_y(ix)
      add #50
      ld h_y(ix), a

      no_change_yi_left2:

      ld hl, #_chicago30Boss
       call change_sprite
      ld  hl, #enemy_move_pattern_4_right_up
      ld  b_up_l(ix), l
      ld  b_up_h(ix), h

      ret 

  cambiar_pattern_4_left_go_down:

  ld  hl, #enemy_move_pattern_4_left_down
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret

enemy_move_pattern_4_right_down:
  ld h_dir(ix), #1
  ld hl, #_chicago30Boss
  call change_sprite
  call detect_hero_control2
  cp #0
  ret nz

  call check_xf
  jr z, cambiar_pattern_4_right_down

    call move_right

    ret

  cambiar_pattern_4_right_down:

  call check_yf
  jp z, cambiar_pattern_4_right_go_up

    ld a, h_y(ix)
    add #50
    ld h_y(ix), a
    call check_collision_hero
    cp #0
    jp z, no_change_right_down2

      ld a, h_y(ix)
      sub #50
      ld h_y(ix), a

      no_change_right_down2:

      ld hl, #_chicago30Boss_flip
      call change_sprite
      ld  hl, #enemy_move_pattern_4_left_down
      ld  b_up_l(ix), l
      ld  b_up_h(ix), h

      ret 

  cambiar_pattern_4_right_go_up:

  ld  hl, #enemy_move_pattern_4_right_up
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret


enemy_move_pattern_4_left_down:
  ld h_dir(ix), #0
  ld hl, #_chicago30Boss_flip
  call change_sprite
  call detect_hero_control2
  cp #0
  ret nz

  call check_xi
  jr z, cambiar_pattern_4_left_down

    call move_left

    ret

  cambiar_pattern_4_left_down:

  call check_yf
  jp z, cambiar_pattern_4_left_go_up

    ld a, h_y(ix)
    add #50
    ld h_y(ix), a
    call check_collision_hero
    cp #0
    jp z, no_change_left_down2

      ld a, h_y(ix)
      sub #50
      ld h_y(ix), a

      no_change_left_down2:

      ld hl, #_chicago30Boss
      call change_sprite
      ld  hl, #enemy_move_pattern_4_right_down
      ld  b_up_l(ix), l
      ld  b_up_h(ix), h

      ret 

  cambiar_pattern_4_left_go_up:

  ld  hl, #enemy_move_pattern_4_left_up
  ld  b_up_l(ix), l
  ld  b_up_h(ix), h 
  
  ret

detect_hero_control2:
  ld b, #1              ;; detecta al heroe de frente y de espaldas 
  call detect_hero      ;; detect hero devuelve 1 si el enemigo lo ha visto en su fila
  cp #0
  jr z, mover2
    ld b, #1

    ld  h, e_shh(ix)
    ld  l, e_shl(ix)
    ld  (shoot2), hl

    shoot2 = . + 1
    call shoot2
    ld a, #-1

    ret

  mover2:
    ld a, #0

ret
