;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "entity.h.s"
.include "cpctelera.h.s"
.include "utils.h.s"
.include "weapon.h.s"
.include "hero.h.s"
.include "bullet.h.s"

;;====================================
;; Clears entity on the screen
;; DESTROYS: DE, BC, HL, IX
;;====================================
ent_clear:
  call render_draw
   ret
;;======
;;====================================
;; Clears entity on the screen using IY
;; DESTROYS: DE, BC, HL, IY
;;====================================
ent_moveRight:
  ld a, h_x(ix)
  inc a 
  inc a
  ld h_x(ix), a
  ret
;;====================================
;; Moves entity at the left
;; DESTROYS: AF, IX
;;====================================
ent_moveLeft:
  ld a, h_x(ix)
  dec a 
  dec a
  ld h_x(ix), a
  ret
;;====================================
;; Updates entity
;; DESTROYS: HL,IX
;;====================================
ent_update: 
  ld     h, b_up_h(ix)
  ld     l, b_up_l(ix)
  jp (hl)
  ret
