;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.globl reduce_cooldown
.globl drawBox
.globl cpct_disableFirmware_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl cpct_scanKeyboard_asm 
.globl cpct_isKeyPressed_asm
.globl cpct_waitVSYNC_asm
.globl cpct_etm_setDrawTilemap4x8_ag_asm
.globl cpct_etm_drawTilemap4x8_ag_asm

.globl _pj_running
.globl _pj_shooting 
.globl _pj_swattack
.globl _pj_swrunning
.globl _pj_swrunning2
.globl _pj_swstill
.globl _pj

.globl change_sprite
.globl obstacleCheck
.globl teleport_up
.globl teleport_up_control
.globl tel_control
.globl teleport_down
.globl teleport_down_control
.globl exit_tel
.globl hero_doForAll
.globl just_check
.globl check_floor
.globl falling
.globl updateHero
.globl hero_main

.globl shoot_status
.globl k_wall_size 
.globl m_num_wall
.globl k_wall_size
.globl wall_vector
.globl check_bullets_collisions
.globl check_a_collision
.globl hero

.globl hero_pattern
.globl reset_hero
.globl is_up
.globl current_view
.globl cpct_getScreenToSprite_asm
.globl cpct_drawSprite_asm

.globl shootHero_status
.globl changeW_status
.globl save_background_hero
.globl init_obstacles

.globl hearts_remaining
.globl draw_hud

.macro DefineHero _name,_x,_y,_w,_h,_sp, _telecooldown,_shieldstatus, _dir, _telestatus, _floor, _upd,_sts,  _c_cd, _b_cd, _wp, _bullets, _shield, _vw, _shootStatus, _cw_status
_name:
   DefineDrawableEntity _name'_dw, _x, _y, _w, _h, _sp, _vw
   .db     _telecooldown
   .db     _shieldstatus
   .db    _dir ;; Left direction or right? 1= right 0 = left
   .db    _telestatus
   .dw   _floor
   .dw   _upd        ;; Update
   .db   _sts     ;;Status: up or crouch   
   .db   _c_cd   ;; Crouch cooldown
   .db   _b_cd  ;; Bullet cooldown
   .db _wp  ;; 0 =  pistol 1 =  sword
   .db _bullets ;;Number of bullets
   .db _shield  ;; Has shield?
   .db _shootStatus     ;; shoot cooldown
   .db _cw_status       ;; change weapon cooldown
 
.endm


h_tc = 7
h_ss = 8 
h_dir = 9 
h_ts = 10 
h_f_l = 11
h_f_h = 12 
h_mov_l = 13 
h_mov_h = 14
h_stat = 15
c_cd = 16 
b_cd = 17 
h_wp = 18 
h_bull = 19
h_shld = 20 
s_cd = 21
cw_cd = 22


is_up = 70
is_crouched = 71
