;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "utils.h.s"
.include "weapon.h.s"
.include "bullet.h.s"
.include "buffer.h.s"
.include "enemy.h.s"
.include "object.h.s"
.include "levels.h.s"
.include "entity.h.s"
.include "menu.h.s"
.include "hero.h.s"



;; #############################
;; # HERO DATA
;; ############################# 



DefineHero hero, 10, 175, 6, 21,_pj, 5, -1, 1, -1, 0x0000,0x0000, is_up, 30, 100, 0, 20,0, 0, 20, 10
DefineDrawableEntity backgroundh, 0, 0, 0, 0, 0x0000, 0

DefineDrawableEntity hud_heart, 0, 0, 6, 10, _empty_heart, 0


crouch_status: .db #-1       ;; 0 = Just crouched (Activate Cooldown) / 1 = Free to crouch
falling_status: .db #-1       ;; 0 = Falling / 1 = Free to fall
current_view:: .db #0
shootHero_status: .db #-1          
changeW_status: .db #-1
running_status: .db #0
pressed_move: .db #0
flip_status: .db #1

coordinate_x: .db #1
number: .db #0
hearts_remaining: .db #5

DefineHero hero_pattern, 10, 175, 6, 21,_pj, 5, -1, 1, -1,  0x0000, 0x0000,is_up, 30, 100, 0,20, 0, 0, 20, 10

reset_hero::
  ld  de, #hero
  ld  hl, #hero_pattern
  ld  bc, #23
  ldir

  ld  a, #-1
  ld  (crouch_status), a
  ld  (falling_status), a
  ld  (shootHero_status), a
  ld  (changeW_status), a

  ld  a, #0
  ld  (current_view), a
  ld  (running_status), a
  ld  (pressed_move), a

  ld a, #5
  ld (hearts_remaining), a

  ret




;; =============================================================
;; FUNCION DRAWOBSTACLE
;; Inputs: IX = Pointer to the object to draw
;; Destroy: A, BC, DE, HL
;; =============================================================

drawObstacle::
  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0
  ld    b, h_y(ix)                 ;; B = y coordinate (24 = 0x18)
  ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  
   ex    de,   hl                   ;; Cambiar contenido de HL y DE
   ld a, (current_enemies)
   cp #0 
   jr z, door_opened
    ld h, h_sp_h(ix)
    ld l, h_sp_l(ix)
    jp change_door
    door_opened:
    ld hl, #_open_door

  change_door:
   ld    b,    h_h(ix)       
   ld    c,    h_w(ix)              ;; Cargar alto en B y ancho en C
   call cpct_drawSprite_asm       ;; Dibujar Cubo

   ret

back_ground:

  
  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0x00

  ld    b, h_y(ix)                 ;; B = y coordinate (24 = 0x18)
  ld    h_y(iy), b

  ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)
  ld    h_x(iy), c


  ld    c, h_w(ix)
  ld    h_w(iy), c

  ld    b, h_h(ix)
  ld    h_h(iy), b


ret

save_background_hero:

  push iy

  ld iy, #backgroundh
  call back_ground

  pop iy

ret

draw_back_ground:

  
  ld d, a
  ld e, #0x00
  ld    b, h_y(ix)                 ;; B = y coordinate (24 = 0x18)
  ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  

  ex de, hl

  ld a, #0x00

  ld c, h_w(ix)
  ld b, h_h(ix)

  call cpct_drawSolidBox_asm

ret

draw_background_hero:

  push ix

  ld ix, #backgroundh
  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  call draw_back_ground

  pop ix

ret

draw_background_hero_front:

  push ix

  ld ix, #backgroundh
  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  call draw_back_ground

  pop ix

ret

;; =============================================================
;; FUNCION DRAWBOX
;; Inputs: IX = Pointer to the object to draw
;; =============================================================

drawBox::

  call render_draw

  ret


obstacleCheck::

   ld ix,   #hero
   
   ;; hero_x + hero_w <= obstacle_x
   ;; hero_x + hero_w - obstacle_x <= 0


   ld    a,    h_x(ix)                    ;; A = hero_X
   add   h_w(ix)                          ;; A = hero_x + hero_w
   sub   h_x(iy)                          ;; A = hero_x + hero_w - obstacle_x
   jp    m, no_colision

   ;; obstacle_x + obstacle_w <= hero_x
   ;; obstacle_x + obstacle_w - hero_x <= 0

      ld    a,    h_x(iy)                 ;; A = Obstacle_X
      add   h_w(iy)                       ;; A = Obstacle_x + Obstacle_w             
      sub   h_x(ix)                       ;; A = Obstacle_x + Obstacle_w - hero_x
      jp    m, no_colision


         ;;CHECK IF IM ON TOP OF A BLOCK

         ld    a,    h_y(iy)              ;; A = Obstacle_y
         add   h_h(iy)                    ;; A = Obstacle_y + Obstacle_h             
         sub   h_y(ix)                    ;; A = Obstacle_y + Obstacle_y - hero_y
         jp    m, no_colision


         ;; hero_y + hero_h <= obstacle_y
         ;; hero_y + hero_h - obstacle_y <= 0

         ;; CHECK IF IM DOWN OF A BLOCK

         ld    a,    h_y(ix)              ;; A = hero_y
         add   h_h(ix)                    ;; A = hero_y + hero_h
         sub   h_y(iy)                    ;; A = hero_y + hero_w - obstacle_y
         jp    m, no_colision

            ld    a, #4   ;; If a colision was detected load in A a 4
            
            ret


   no_colision:

      ld    a, #0     ;; If no colision was detected load in A a 0

   ret

;; =============================================================
;; FUNCTION TELEPORT_UP
;; Inputs: IX = Pointer to hero data
;; Destroy: IX, IY, A, BC, HL
;; =============================================================

teleport_up::

   ld    a,   h_y(ix)                       ;; Load Y Coordinate from Hero in A
   add   #-50                               ;; Add -50 to Y Coordinate (It goes up)
   ld    h_y(ix), a                         ;; Update value in memory

   ld    hl, #just_check                    ;; Load in HL the method just_check
   ld    a,  (m_num_obs)                    ;; Load in A the number of the Floors
   ld    bc,  (obstacle_vector)              ;; Load in BC pointer to the Floors vector
   ld    de, #k_obs_size
   call hero_doForAll                       ;; Check all the Floors if there is a Floor above

   cp #0                                    ;; Compare A with 0
   jr    z,    no_teleport_up               ;; If A == 0 (No floor above) -> No teleport up

      ;; Check if teleport permision

      ld    a,    h_tel(iy)                 ;; Load in A the teleport status value from the floor detected
      cp    #-1                             ;; Compare A with -1
      jr    z,    no_teleport_up            ;; If A == -1 (The Floor does not allow teleport) -> No teleport up


          ;; CHECK IF WALL
          ld hl,  #just_check               ;; Load in HL the method just_check 
          ld bc,  (wall_vector)              ;; Load in BC pointer to the Walls vector
          ld a, (m_num_wall)                ;; Load in A the number of the Walls
          ld de, #k_wall_size
          call hero_doForAll                ;; Check all the Walls if there is a Walls above

          cp #-1                            ;; Compare A with -1
          jr  z, no_teleport_up             ;; If A == -1 (There is a Wall above) -> No teleport up

            ld hl,  #just_check
            ld bc, (enemy_vector)
            ld a, (m_num_enemy)
            ld de, #k_enemy_size
            call hero_doForAll

            cp #-1 
            jr  z, no_teleport_up             ;; If A == -1 (There is a enemy above) -> No teleport up

              ld    h_ts(ix),   #-2           ;; Change teleport status to -2 (Just Teleported)

      ret
 
   no_teleport_up:

      ;; Revert Y coordinate

      ld    a,   h_y(ix)        ;; Load Y Coordinate from the hero in A
      add   #50                 ;; Add 50 to the Y Coordinate in A (It goes Down again, to the initial position)
      ld    h_y(ix), a          ;; Update in Memory the Y Coordinate
      ld    h_ts(ix),   #-1     ;; Change teleport status to -1 (Not teleporting)

   ret

;; =============================================================
;; FUNCTION TELEPORT_UP_CONTROL
;; Inputs: IX = Pointer to hero data
;; Destroy: IX, A
;; =============================================================

teleport_up_control::



   ld    a,    h_ts(ix)         ;; Load Teleport Status
   cp    #-2                    ;; Compare A with -2
   jp    z,   exit_tel          ;; If A == -2 (Just teleported) -> Exit

      cp    #-1                 ;; Compare A with -1
      jp   z,  exit_tel         ;; If A == -1 (Not teleporting) -> Exit

         call teleport_up       ;; Teleporting UP
         ret

   ret

;; =============================================================
;; FUNCTION TEL_CONTROL
;; Inputs: IX = Pointer to hero data
;; Destroy: IX, A
;; =============================================================

tel_control::

   ld    a,    h_ts(ix)         ;; Load Teleport Status
   cp    #-2                    ;; Compare A with -2
   jr    z,   reduce_cooldown   ;; If A == -2 (Just teleported) -> Reduce Teleport Cooldown

   ret

;; =============================================================
;; FUNCTION REDUCE_COOLDOWN
;; Inputs: IX = Pointer to hero data
;; Destroy: IX, A
;; =============================================================

reduce_cooldown::

      dec   h_tc(ix)             ;; Decrease teleport cooldown in memory
      ld    a,    h_tc(ix)       ;; Load in A teleport cooldown
      cp    #0                   ;; Compare A with 0
      ret nz                     ;; If A != 0 (Cooldown != 0) -> Exit

         ;; Restart cooldown

         ld h_tc(ix),   #5       ;; Load in Teleport Cooldown the value 30
         ld h_ts(ix),   #-1      ;; Load in Teleport Status the value -1 (Teleport Ready to use again/Not teleporting)
      ret

;; =============================================================
;; FUNCTION TELEPORT_DOWN
;; Inputs: IX = Pointer to hero data
;; Destroy: IX, IY, A, BC, HL
;; =============================================================

teleport_down::

   ld    a, h_f_h(ix)                         ;; Load in A the High Value of the pointer of the Floor under you
   .dw 0x67FD                                 ;; ld iyh, a (Load in IYH the value of A)
   ld    a, h_f_l(ix)                         ;; Load in A the Low Value of the pointer of the Floor under you
   .dw 0x6FFD                                 ;; ld iyl, a (Load in IYL the value of A)

   ld    a,   h_tel(iy)                       ;; Load in A the Teleport Permission of the floor under you
   cp    #-1                                  ;; Compare A with -1
   jr    z, nothing                           ;; If A == -1 (Floor does not allow Teleport) -> Exit

      ld    a,   h_y(ix)                      ;; Load Y Coordinate from Hero Data in A
      add   #50                               ;; Add -50 to Y Coordinate (It goes up) 
      ld    h_y(ix), a                        ;; Update Y Coordinate in Hero Data

      ld    hl, #just_check                   ;; Load in HL the method just_check
      ld    a,  (m_num_obs)                   ;; Load in A the number of the Floors
      ld    bc,  (obstacle_vector)             ;; Load in BC pointer to the Floors vector
      ld    de, #k_obs_size
      call hero_doForAll                      ;; Check all the Floors if there is a Floor above

      cp #0                                   ;; Compare A with 0
      jr    z,    no_teleport_down            ;; If A == 0 (No floor down) -> No Teleport Down

          ;; CHECK IF WALL
          ld hl,  #just_check                 ;; Load in HL the method just_check 
          ld bc,  (wall_vector)                ;; Load in BC pointer to the Walls vector
          ld a, (m_num_wall)                  ;; Load in A the number of the Walls
          ld de, #k_wall_size
          call hero_doForAll                  ;; Check all the Walls if there is a Walls under

          cp #-1                              ;; Compare A with -1
          jr  z, no_teleport_down             ;; If A == -1 (There is a Wall down) -> No Teleport Down

            ld hl,  #just_check
            ld bc, (enemy_vector)
            ld a, (m_num_enemy)
            ld de, #k_enemy_size
            call hero_doForAll

            cp #-1 
            jr  z, no_teleport_down             ;; If A == -1 (There is a enemy down) -> No teleport down

              ld    h_ts(ix),   #-2           ;; Change Teleport Status to -2 (Just teleported)

         ret
    
      no_teleport_down:

         ;; Revert Y coordinate

         ld    a,   h_y(ix)       ;; Load Y Coordinate from Hero Data in A
         add   #-50               ;; Add -50 to the Y Coordinate (Set to inital position)
         ld    h_y(ix), a         ;; Update Y Coordinate in Hero Data
         ld    h_ts(ix),   #-1    ;; Set Teleport Status to -1 (Not teleporting)

   nothing:

   ret

;; =============================================================
;; FUNCTION TELEPORT_DOWN_CONTROL
;; Inputs: IX = Pointer to hero data
;; Destroy: IX, A
;; =============================================================

teleport_down_control::



   ld    a,    h_ts(ix)         ;; Load in A Teleport Status
   cp    #-2                    ;; Compare A with -2
   jr    z,   exit_tel          ;; If A == -2 (Just teleported) -> Exit

      cp    #-1                 ;; Compare A with -1
      jr   z,  exit_tel         ;; If A == -1 (Not Teleporting) -> Exit

         call teleport_down     ;; Teleport DOWN

exit_tel::

   ret

;; =============================================================
;; FUNCTION HERO_DOFORALL
;; Inputs: IX = Pointer to array
;;     HL -> Pointer to method
;;     A -> Pointer to number of Objects in the array
;;     BC -> Pointer to Objects Array
;;     DE -> Pointer to size of Object
;; Destroy: IX, IY, A, BC, HL, DE
;; =============================================================

hero_doForAll::

  cp #0                             ;; Compare A with 0
  jr z,no_hacer_nada                ;; If A == 0 (No Objects in the array) -> Exit

  

  push bc                           ;; |
  pop ix                            ;; \ IX points to array

  ld  (metodo), hl                  ;; Load method pointer in "metodo" position

buc::
  push de
  push  af                          ;; Put AF value in the Stack

  ld  a, (current_view)
  sub h_vw(ix)
  jr nz, here


  metodo = . + 1                    
  call  drawBox                     ;; Call to the method (not drawBox)

  ;; Only for checking things
  cp #4                             ;; Compare A with 4
  jr  z,    finish_all              ;; If A == 4 (Something Found) -> Finish All

     ;; Nothing Found Yet

     here:

     pop   af                       ;; Put the first Stack value in AF
     pop   de                       
     ;;ld   bc,   #k_obs_size
     add   ix,   de                 ;; \ Add size to the array pointer

     dec   a                        ;; Decrese in 1 the number of Objects in array (Not Updated)
     jr    nz,   buc                ;; If A != 0 (Still ) -> Do it again

     ;; Nothing Found Finally

     ld  a,    #0                   ;; A = 0 -> Nothing Found

     ld ix,   #hero                 ;; Reset IX with Hero Data Pointer
     
     ret

  finish_all:

   push ix            ;; |
   pop iy             ;; \ Exchange IY <-> IX so IY has Obstacle Data

   pop   af           ;; Put the first Stack value in AF 
   pop   de

   ld  a,    #-1      ;; Obstacle found

   ld ix,   #hero     ;; Reset IX with Hero Data Pointer

  no_hacer_nada:
  ret


;; =============================================================
;; FUNCTION JUST_CHECK
;; Inputs: IX = Pointer to obstacle Data
;; Destroy: IX, IY, A
;; =============================================================

just_check::
   push ix                            ;; |
   pop iy                             ;; | Exchange IY <-> IX so IY has Obstacle Data

   ld ix,   #hero                     ;; Load Hero data Pointer in IX

   call obstacleCheck                 ;; Check the colissions with Hero
   cp #0                              ;; Compare A with 0
   jr z, finish_just_check_floor      ;; If A == 0 (No Colission detected) -> Exit

   ld a,    #4                        ;; Load in A a 4 (Something Founded) 

   finish_just_check_floor:

      push iy                         ;; |
      pop ix                          ;; | Exchange IY <-> IX so IX has Obstacle Data

   ret

;; =============================================================
;; FUNCTION CHECK_FLOOR
;; Inputs: IX = Pointer to obstacle Data
;; Destroy: IX, IY, A
;; =============================================================
check_floor::

   push ix                      ;; |
   pop iy                       ;; | Exchange IY <-> IX so IY has Obstacle Data

   ld ix,   #hero               ;; Load box data

   call obstacleCheck           ;; Check the colissions with Hero
   cp #0                        ;; Compare A with 0
   jr z, finish_check_floor     ;; If A == 0 (No Colission detected) -> Exit

      .dw 0x7CFD                ;; |
      ld h, a                   ;; |
      .dw 0x7DFD                ;; |
      ld l, a                   ;; | Load in HL = IY

      ld h_f_l(ix), l           ;; |
      ld h_f_h(ix), h           ;; | Load in Hero data the Floor Pointer

      ld a,    #4               ;; Load in A a 4 (Something Founded) 

   finish_check_floor:

      push iy                   ;; |
      pop ix                    ;; | Exchange IY <-> IX so IX has Obstacle Data

   ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; APUNTA IY AL TECLADO O AL JOYSTICK
;; REGITROS DESTRUIDOS: IY, A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
configureControls:
  ld a, (option)    
  cp #1
  jr z, use_joystick

  cp #2
  jr z, use_keyboard

  use_keyboard:
    ld iy, #keyboard
    jr continueCC

  use_joystick:
    ld iy, #joystick
  
  continueCC:
  ret

flipAllSprites::
  
  ld hl , #_pj
  call change_sprite
  call flip_sprite

  ld hl , #_pj_crouched
  call change_sprite
  call flip_sprite

  ld hl , #_pj_running
  call change_sprite
  call flip_sprite

  ld hl , #_pj_running2
  call change_sprite
  call flip_sprite

  ld hl , #_pj_shooting
  call change_sprite
  call flip_sprite

  ld hl , #_pj_swattack
  call change_sprite
  call flip_sprite

  ld hl , #_pj_swrunning
  call change_sprite
  call flip_sprite

  ld hl , #_pj_swrunning2
  call change_sprite
  call flip_sprite

  ld hl , #_pj_swstill
  call change_sprite
  call flip_sprite

ret

running_control:
  
  ld a, (running_status)
  cp #0
  jp nz, run_control

    ld a, h_wp(ix)
    cp #0
    jp z, use_pistol
    

      ld hl, #_pj_swstill
      call change_sprite

      ret

    use_pistol:
    ld hl, #_pj
    call change_sprite

  ret

  run_control:
  cp #1
  jp z, change1

    ld a, h_wp(ix)
    cp #0
    jp z, use_pistol_running2

      ld hl, #_pj_swrunning2
      call change_sprite

      ld a, #1
      ld (running_status), a

      ret

    use_pistol_running2:

    ld hl, #_pj_running2
    call change_sprite

    ld a, #1
    ld (running_status), a

  ret

  change1:

      ld a, h_wp(ix)
      cp #0
      jp z, use_pistol_running

          ld hl, #_pj_swrunning
          call change_sprite

          ld a, #2
          ld (running_status), a

          ret

      use_pistol_running:

    ld hl, #_pj_running
    call change_sprite

    ld a, #2
    ld (running_status), a

ret

;; =============================================================
;; FUNCTION UPDATEHERO
;; Inputs: IX = Pointer to obstacle Data
;; Destroy: IX, A
;; =============================================================
updateHero::
  call configureControls
  call cpct_scanKeyboard_asm          ;; Scan Keyboard


  ld   a, (falling_status)
  cp   #0
  jp   z, c_no_pulsada

  ld   a,  h_stat(ix)  
  cp   #is_up      
  jp  nz, S_not_pressed

  ld a, #0
  ld (pressed_move), a

  ld    h, k_right_h(iy)
  ld    l, k_right_l(iy)   ;;  HL = Key D id
  call cpct_isKeyPressed_asm          ;; Check if D was pressed
  jp    z, D_not_pressed    
            ;; Jump if register A==0

      ld a, #1
      ld (pressed_move), a


      ld a, #1
      ld h_dir(ix), a
                                
      ld a, (flip_status)
      cp h_dir(ix)
      jp z, dont_change

        call flipAllSprites
        ld  a, #1
        ld (flip_status), a


        ;; Key D Pressed 
        dont_change:

        ld a, (running_status)
        cp #2
        jp z, running_D

          ld a, #1
          ld  (running_status), a
        
        running_D:  

         ld    a,    h_x(ix)
         add   #1     
         cp    #80-5                
         jr    nz, continueD

            call rightView
            jp D_not_pressed

              continueD:
               ld hl, #Key_Shift                      ;; HL = Key Shift id
               call  cpct_isKeyPressed_asm            ;; Check if Shift was pressed
               jr    z, SHIFT_D_not_pressed           ;; Jump if Shift was not pressed

                    ld    a,    h_x(ix)          
                    add  #2                
                    cp    #80-5             
                    jr    nz, continueDSHIFT

                      call rightView
                      jp D_not_pressed

                    continueDSHIFT: 

                    inc h_x(ix)                       ;; Increase X Coordinate  
                    inc h_x(ix)                       ;; Increase X Coordinate  

                    ;; CHECK IF WALL
                    ld hl,  #just_check               ;; Load in HL the method just_check 
                    ld bc,  (wall_vector)              ;; Load in BC pointer to the Walls vector
                    ld a, (m_num_wall)                ;; Load in A the number of the Walls
                    ld de, #k_wall_size
                    call hero_doForAll                ;; Check all the Walls if there is a Walls under

                    cp #-1                            ;; Compare A with -1
                    jr  nz, D_enemy_not_pressed             ;; If A != -1 (Wall not detected) -> D_NOT_PRESSED

                        dec h_x(ix)                     ;; Decrease X Coordinate
                        dec h_x(ix)                     ;; Decrease X Coordinate

                        jr D_not_pressed

                
                    D_enemy_not_pressed:

                      ld hl,  #just_check
                      ld bc, (enemy_vector)
                      ld a, (m_num_enemy)
                      ld de, #k_enemy_size
                      call hero_doForAll

                      cp #-1                            ;; Compare A with -1
                      jr  nz, D_not_pressed

                      ;; ENEMY DETECTED

                        dec h_x(ix)                     ;; Decrease X Coordinate
                        dec h_x(ix)                     ;; Decrease X Coordinate

                    jr    D_not_pressed               ;; Jump to D_not_pressed

               SHIFT_D_not_pressed:
                  inc h_x(ix)                         ;; Increase X Coordinate  

                  ;; CHECK IF WALL
                  ld hl,  #just_check                 ;; Load in HL the method just_check 
                  ld bc,  (wall_vector)                ;; Load in BC pointer to the Walls vector
                  ld a, (m_num_wall)                  ;; Load in A the number of the Walls
                  ld de, #k_wall_size
                  call hero_doForAll                  ;; Check all the Walls if there is a Walls under

                  cp #-1                              ;; Compare A with -1
                  jr  nz, SHIFT_D_enemy_not_pressed               ;; If A != -1 (Wall not detected) -> D_NOT_PRESSED

                    dec h_x(ix)                       ;; Decrease X Coordinate

                    jr D_not_pressed

                  SHIFT_D_enemy_not_pressed:

                      ld hl,  #just_check
                      ld bc, (enemy_vector)
                      ld a, (m_num_enemy)
                      ld de, #k_enemy_size
                      call hero_doForAll
                    

                  ;;call check_hero_collision_enemy                ;; Check all the enemy if there is a enemy under
                  cp #-1                            ;; Compare A with -1
                  jr  nz, D_not_pressed
                    ;; WALL DETECTED
                    dec h_x(ix)                       ;; Decrease X Coordinate  

                    

   ;; Key D NOT pressed
   D_not_pressed:
      call configureControls

      ld    h, k_left_h(iy)
      ld    l, k_left_l(iy)
      call cpct_isKeyPressed_asm          ;; Check if A was pressed
      jp    z, A_not_pressed              ;; Jump if register A==0

      ld a, #1
      ld (pressed_move), a

      ld a, #0
      ld h_dir(ix), a
                                
      ld a, (flip_status)
      cp h_dir(ix)
      jr z, dont_change2

        call flipAllSprites
        ld a, #0
        ld (flip_status), a
           
        dont_change2:

        ld a, (running_status)
        cp #2
        jp z, running_A

        ld a, #1
        ld  (running_status), a
        
        running_A: 

         ld    a,    h_x(ix)
         sub #1     
         cp    #00                
         jr    nz, continueA

          call leftView
          jp A_not_pressed

         continueA:

            ld hl, #Key_Shift                         ;; HL = Key Shift id
            call  cpct_isKeyPressed_asm               ;; Check if Shift was pressed;
            jr    z, SHIFT_A_not_pressed              ;; Jump if Shift was not pressed

              ld    a,    h_x(ix)                 
              sub   #2                  
              cp    #00                  
              jr    nz, continueASHIFT

                call leftView
                jp A_not_pressed                  

                continueASHIFT:
                 dec h_x(ix)                          ;; Decrease X Coordinate
                 dec h_x(ix)                          ;; Decrease X Coordinate

                ;; CHECK IF WALL
                  ld hl,  #just_check                 ;; Load in HL the method just_check 
                  ld bc,  (wall_vector)                ;; Load in BC pointer to the Walls vector
                  ld a, (m_num_wall)                  ;; Load in A the number of the Walls
                  ld de, #k_wall_size
                  call hero_doForAll                  ;; Check all the Walls if there is a Walls under

                cp #-1                                ;; Compare A with -1
                jr  nz, A_enemy_not_pressed                 ;; If A != -1 (No wall detected) -> A_not_pressed

                  inc h_x(ix)                         ;; Increase X Coordinate
                  inc h_x(ix)                         ;; Increase X Coordinate

                  jr A_not_pressed

                A_enemy_not_pressed:

                  ld hl,  #just_check
                  ld bc, (enemy_vector)
                  ld a, (m_num_enemy)
                  ld de, #k_enemy_size
                  call hero_doForAll

                  cp #-1                            ;; Compare A with -1
                  jr  nz, A_not_pressed

                  ;; ENEMY DETECTED

                  inc h_x(ix)                         ;; Increase X Coordinate
                  inc h_x(ix)                         ;; Increase X Coordinate

                 jr    A_not_pressed                  ;; Jump to A_not_pressed

            SHIFT_A_not_pressed:
                dec h_x(ix)                           ;; Decrease X Coordinate

                ;; CHECK IF WALL
                  ld hl,  #just_check                 ;; Load in HL the method just_check 
                  ld bc,  (wall_vector)                ;; Load in BC pointer to the Walls vector
                  ld a, (m_num_wall)                  ;; Load in A the number of the Walls
                  ld de, #k_wall_size
                  call hero_doForAll                  ;; Check all the Walls if there is a Walls under

                cp #-1                                ;; Compare A with -1
                jr  nz, SHIFT_A_enemy_not_pressed                 ;; If A != -1 (No wall detected) -> A_not_pressed

                  inc h_x(ix)                         ;; Increase X Coordinate

                  jr A_not_pressed

                SHIFT_A_enemy_not_pressed:

                  ld hl,  #just_check
                  ld bc, (enemy_vector)
                  ld a, (m_num_enemy)
                  ld de, #k_enemy_size
                  call hero_doForAll
                  cp #-1                            ;; Compare A with -1
                  jr  nz, A_not_pressed

                  ;; ENEMY DETECTED

                    inc h_x(ix)                         ;; Increase X Coordinate

   ;; Key A NOT pressed
   A_not_pressed:

   call configureControls

      ld    h, k_up_h(iy)
      ld    l, k_up_l(iy)
      call cpct_isKeyPressed_asm          ;; Check if W was pressed
      jr    z, W_not_pressed              ;; Jump if register A==0

         ;; Key W Pressed
         ld    a,    h_ts(ix)                         ;; Load in A Teleport Status
         cp    #-2                                    ;; Compare A with -2
         jr    z, W_not_pressed                       ;; If A == -2 (Just teleported) -> W_not_pressed

               ld h_ts(ix), #0                        ;; Change Teleport Status to 0 (Teleporting)
               call teleport_up_control               ;; Teleport UP

      ;; Key W NOT pressed
   W_not_pressed:
      call configureControls

      ld    h, k_down_h(iy)
      ld    l, k_down_l(iy)
      call cpct_isKeyPressed_asm          ;; Check if S was pressed
      jr    z, S_not_pressed              ;; Jump if register A==0

         ;; Key S Pressed
         ld    a,    h_ts(ix)                         ;; Load in A Teleport Status
         cp    #-2                                    ;; Compare A with -2
         jr    z, S_not_pressed                       ;; If A == -2 (Just teleported) -> S_not_pressed

               ld h_ts(ix), #0                        ;; Change Teleport Status to 0 (Teleporting)
               call teleport_down_control             ;; Teleport DOWN

   ;; Key S NOT pressed
   S_not_pressed:
      ld    hl, #Key_C                                ;; HL = Key C id
      call  cpct_isKeyPressed_asm                     ;; Check if C was pressed
      jr    z, c_no_pulsada                           ;; Jump if C was not pressed

            ;; Key C Pressed
            ld a, (crouch_status)                     ;; Load in A Crouch Status
            cp #0                                     ;; Compare A with 0
              jr  z,  c_no_pulsada                    ;; If A == 0 (Crouch in cooldown) -> C_no_pulsada
                call hero_crouch                      ;; Call hero_crouch

  ;; Key C NOT pressed
   c_no_pulsada:

   ld a, (pressed_move)
   cp #0
   ret nz

   ld a, #0
   ld (running_status), a

   ret

;; =============================================================
;; FUNCTION RIGHTVIEW
;; Destroy: A
;; =============================================================

rightView:
  ld a, (current_view)
  add #1
  ld (current_view), a

  ld h_x(ix), #02

  call clearBuffer
  call switchBuffers
  call clearBuffer
  call switchBuffers
  
  call restart_bullets
  call init_obstacles
  call init_objects

  ld ix, #hero
  call save_background_hero

ret

;; =============================================================
;; FUNCTION LEFTVIEW
;; Destroy: A
;; =============================================================

leftView:
  ld a, (current_view)
  sub #1
  ld (current_view), a

  ld h_x(ix), #73

  call clearBuffer
  call switchBuffers
  call clearBuffer
  call switchBuffers

  call restart_bullets
  call init_obstacles
  call init_objects

  ld ix, #hero
  call save_background_hero

ret

;; =============================================================
;; FUNCTION INIT_OBSTACLES
;; Destroy: A, BC, HL, DE
;; =============================================================

draw_door::
  ld hl, #drawObstacle 
  ld a, #1
  ld bc, (door_vector)
  ld de, #7
  call hero_doForAll
  ret

;; =============================================================
;; FUNCTION CHEKC_DOOR
;; Destroy: IX, A, BC, HL
;; =============================================================

check_door:

  ld hl, #just_check              ;; Load in HL pointer to method
  ld    a,  #1          ;; Load in A the number of Hidden Places
  ld    bc,  (door_vector)           ;; Load in BC pointer of Hidden Places Array
  ld de, #k_door_size
  call hero_doForAll                ;; Call to hero_doForAll

  cp #-1                            ;; Compare A with -1
  ret  nz
      ld a, (current_enemies)
      cp #0
      ret nz

        ld    ix,   #hero  
        ld  h_x(ix), #10
        ld  h_y(ix), #175

        ld  a, #0
        ld  (current_view), a

        ld a, (actual_level)
        cp #20
        jp z, end_game

        jp next_level

        end_game:

        call show_win
        call esperar

        jp ending_game



    ret

draw_floor:

  ld a, h_x(ix)
  ld (coordinate_x), a
  ld a, #0
  ld (number), a

  floor_loop:

  ld e, #0
  ld    a, (coordinate_x)
  ld    c, a                 ;; B = y coordinate (24 = 0x18)
  ld    b, h_y(ix)                  ;; C = x coordinate (16 = 0x10)
  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  ld d, a

  call cpct_getScreenPtr_asm
  ex    de,   hl                   ;; Cambiar contenido de HL y DE
  
  ld h, obs_sp_h(ix)
  ld l, obs_sp_l(ix)
  ld    b,    h_h(ix)  
  ld    c,    #2            ;; Cargar alto en B y ancho en C
  call cpct_drawSprite_asm       ;; Dibujar Cubo

  ld a, (coordinate_x)
  add #2
  ld (coordinate_x), a
  ld a, (number)
  add #2
  ld (number), a
  sub h_w(ix)
  jp nz, floor_loop

  ret


ret

draw_wall:
  
  ld a, h_y(ix)
  ld (coordinate_x), a
  ld a, #0
  ld (number), a

  wall_loop:

  ld e, #0
  ld    a, (coordinate_x)
  ld    b, a                 ;; B = y coordinate (24 = 0x18)
  ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)
  ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
  ld d, a

  call cpct_getScreenPtr_asm
  ex    de,   hl                   ;; Cambiar contenido de HL y DE
  
  ld h, obs_sp_h(ix)
  ld l, obs_sp_l(ix)
  ld    b,    #4      
  ld    c,    h_w(ix)              ;; Cargar alto en B y ancho en C
  call cpct_drawSprite_asm       ;; Dibujar Cubo

  ld a, (coordinate_x)
  add #4
  ld (coordinate_x), a
  ld a, (number)
  add #4
  ld (number), a
  sub h_h(ix)
  jp nz, wall_loop

  ret


init_obstacles:

  ld hl,  #draw_wall                 ;; Load in HL the method just_check 
  ld bc,  (wall_vector)                ;; Load in BC pointer to the Walls vector
  ld a, (m_num_wall)                  ;; Load in A the number of the Walls
  ld de, #k_wall_size
  call hero_doForAll                  ;; Check all the Walls if there is a Walls under
  call switchBuffers

  ld hl,  #draw_wall                 ;; Load in HL the method just_check 
  ld bc,  (wall_vector)                ;; Load in BC pointer to the Walls vector
  ld a, (m_num_wall)                  ;; Load in A the number of the Walls
  ld de, #k_wall_size
  call hero_doForAll                  ;; Check all the Walls if there is a Walls under
  call switchBuffers

  ld    hl, #draw_floor                   ;; Load in HL the method check_floor
  ld    a,  (m_num_obs)                    ;; Load in A the number of the Floors
  ld    bc,  (obstacle_vector)              ;; Load in BC pointer to the Floors vector
  ld de, #k_obs_size
  call hero_doForAll
  call switchBuffers  

  ld    hl, #draw_floor                   ;; Load in HL the method check_floor
  ld    a,  (m_num_obs)                    ;; Load in A the number of the Floors
  ld    bc,  (obstacle_vector)              ;; Load in BC pointer to the Floors vector
  ld de, #k_obs_size
  call hero_doForAll
  call switchBuffers  

  call draw_hud
  call switchBuffers
  call draw_hud
  call switchBuffers

ret

;; =============================================================
;; FUNCTION HERO_MAIN
;; Destroy: IX, A, BC, HL
;; =============================================================

hero_main::


  ld    ix,   #hero                   ;; Load in IX pointer to Hero Dat
  call save_background_hero

  call updateHero 
  call running_control                 
  call change_weapon                  ;; Change Weapon
  call attack                         ;; Attack
  call crouch_control                 ;; Crouch Control
  call shoot_control                  ;; shoot control
  call changeWeapon_control           ;; change weapon control
  call tel_control                    ;; Teleport Control
  call fall_control                   ;; Fall Control
  call falling                        ;; Falling (if can)
  call check_door
  call pick_object                    ;; Picks an object on the map
  call bullet_control                 ;; Bullet Control

  call update_enemies   

  ld  hl, #enemy_bullet_control
  call enemy_doForAll                 ;; Bullet Control
  ld    ix,   #hero                   ;; Load in IX pointer to Hero Dat

  call update_bullets             ;; Update Bullets
  call check_bullets_collisions       ;; Check Bullets Collisions with Walls
  call check_hero_collisions
  call check_enemies_collisions       ;; Check Enemies Collisions with Bullets



  ld    ix,   #hero                   ;; Load in IX pointer to Hero Dat
  call drawBox                        ;; Draw Hero
  call draw_enemies
  call draw_bullets
  call draw_objects
  call newScene
  call draw_background_hero
  call clearEnemies
  call clearBullets
  call draw_door

   ret

draw_hud:

  push ix

  ld    ix,   #hero                   ;; Load in IX pointer to Hero Dat

  ld a, #5
  ld (number), a
  ld a, #1
  ld (coordinate_x), a
  
  hud_loop:

    ld   a, (coordinate_x)
    ld    c, a
    ld    b, #1
    ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
    ld d, a
    ld e, #0

    call cpct_getScreenPtr_asm  
    ex    de,   hl

    ld hl, #_empty_heart

      ld c, #6
      ld b, #10

    call cpct_drawSprite_asm    ;; Dibujar Cubo

    ld a, (coordinate_x)
    add #7
    ld (coordinate_x), a

    ld a, (number)
    dec a
    ld (number), a

    jr nz, hud_loop

  ld a, (hearts_remaining)
  ld (number), a
  ld a, #1
  ld (coordinate_x), a

  hud_loop_remaining:

    ld   a, (coordinate_x)
    ld    c, a
    ld    b, #1
    ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
    ld d, a
    ld e, #0

    call cpct_getScreenPtr_asm  
    ex    de,   hl

    ld hl, #_full_heart

      ld c, #6
      ld b, #10

    call cpct_drawSprite_asm    ;; Dibujar Cubo

    ld a, (coordinate_x)
    add #7
    ld (coordinate_x), a

    ld a, (number)
    dec a
    ld (number), a

    jr nz, hud_loop_remaining

  ld a, #20
  ld (number), a
  ld a, #57
  ld (coordinate_x), a
  
  hud_loop_bull:

    ld a, (number)
    dec a
    ld (number), a
    jr z, next_bullets

    ld   a, (coordinate_x)
    ld    c, a
    ld    b, #1
    ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
    ld d, a
    ld e, #0

    call cpct_getScreenPtr_asm  
    ex    de,   hl

    ld hl, #_empty_bullet

      ld c, #2
      ld b, #6

    call cpct_drawSprite_asm    ;; Dibujar Cubo

    ld a, (coordinate_x)
    add #1
    ld (coordinate_x), a

    jr hud_loop_bull

  next_bullets:

  ld a, h_bull(ix)
  ld (number), a
  ld a, #57
  ld (coordinate_x), a

  hud_loop_bull_remaining:

    ld a, (number)
    cp #0
    jr z, exit

    dec a
    ld (number), a
    

    ld   a, (coordinate_x)
    ld    c, a
    ld    b, #1
    ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
    ld d, a
    ld e, #0

    call cpct_getScreenPtr_asm  
    ex    de,   hl

    ld hl, #_full_bullet

      ld c, #2
      ld b, #6

    call cpct_drawSprite_asm    ;; Dibujar Cubo

    ld a, (coordinate_x)
    add #1
    ld (coordinate_x), a

    jr hud_loop_bull_remaining
    
    exit:

    ld    c, #43
    ld    b, #1
    ld   a, (m_back_buffer) ;; DE = Pointer to start of the screen
    ld d, a
    ld e, #0

    call cpct_getScreenPtr_asm  
    ex    de,   hl

    ld a, h_shld(ix)
    cp #0
    jr nz, shield_hud
      ld hl, #_shield_no
      jr continue_shield_hud

    shield_hud:

      ld hl, #_shield

    continue_shield_hud:
      ld c, #6
      ld b, #10

    call cpct_drawSprite_asm    ;; Dibujar Cubo

  pop ix

ret

;; =============================================================
;; FUNCTION FALL_CONTROL
;; Inputs: IX = Pointer to Hero Data
;; Destroy: IX, A, BC, HL
;; =============================================================


fall_control:

  ld  a,  (falling_status)                  ;; Load in A Falling Status
  cp  #0                                    ;; Compare A with 0
  ret  z                                    ;; If A == 0 (Falling) -> Exit

   ld    hl, #check_floor                   ;; Load in HL the method check_floor
   ld    a,  (m_num_obs)                    ;; Load in A the number of the Floors
   ld    bc,  (obstacle_vector)              ;; Load in BC pointer to the Floors vector
   ld de, #k_obs_size
   call hero_doForAll                       ;; Check all the Floors if there is a Floor above

    cp #0                                   ;; Compare A with 0
    ret    nz                               ;; If A != 0 (Floor not Detected) -> Exit

        ld  a, #0                           ;; Load in A a 0
        ld (falling_status), a              ;; Update in Falling Status with 0 (Falling)
    ret

;; =============================================================
;; FUNCTION HERO_MAIN
;; Inputs: IX = Pointer to Hero Data
;; Destroy: IX, A, BC, HL
;; =============================================================

falling::

  ld  a,  (falling_status)            ;; Load in A Falling Status
  cp  #0                              ;; Compare A with 0
  ret  nz                             ;; If A != 0 (Not falling) -> Exit

   ;;call eraseBox                      ;; Erase Hero
   call draw_background_hero
   inc   h_y(ix)                      ;; |
   inc   h_y(ix)                      ;; |
   inc   h_y(ix)                      ;; |
   inc   h_y(ix)                      ;; |
   inc   h_y(ix)                      ;; \ Increase Y Coordinate by 5
   call drawBox                       ;; Draw Hero

   ld    hl, #check_floor             ;; Load in HL the method check_floor
   ld    a,  (m_num_obs)              ;; Load in A the number of the Floors
   ld    bc,  (obstacle_vector)        ;; Load in BC pointer to the Floors vector
   ld    de, #k_obs_size
   call hero_doForAll                 ;; Check all the Floors if there is a Floor above

   cp #0                              ;; Compare A with 0
   ret    z                           ;; If A == 0 (Floor not detected) -> Exit

      ld a, #-1                       ;; Load in A a -1
      ld (falling_status), a          ;; Update Falling Status with a -1 (Not Falling)

   ret


crouch_control:

  ld  a,  (crouch_status)
  cp  #0
  ret   nz
      ld  a,  c_cd(ix)
      cp #0
      jr  z,  restart_crouch

        dec c_cd(ix)

        ret

  restart_crouch:
    ld  c_cd(ix), #10
    ld  hl,   #crouch_status
    ld  (hl),  #1

  ret

shoot_control:
  ld  a,  (shootHero_status)
  cp  #0
  ret   nz
      ld  a,  s_cd(ix)
      cp #0
      jr  z,  restart_shoot

        dec s_cd(ix)

        ret

  restart_shoot:
    ld  s_cd(ix), #20
    ld  hl,   #shootHero_status
    ld  (hl),  #1

  ret

changeWeapon_control:
  ld  a,  (changeW_status)
  cp  #0
  ret   nz
      ld  a,  cw_cd(ix)
      cp #0
      jr  z,  restart_changeW

        dec cw_cd(ix)

        ret

  restart_changeW:
    ld  cw_cd(ix), #10
    ld  hl,   #changeW_status
    ld  (hl),  #1

  ret

hero_crouch::

  ld a, h_stat(ix)
  cp #is_up ;;Comprobamos si está de pie o agachado

  jr z, go_crouch  

     ld hl, #_pj
     ld h_w(ix), #6
     ld h_h(ix), #21
     ld a, h_y(ix)
     sub #6
     ld h_y(ix), a
     ld h_sp_l(ix), l
     ld h_sp_h(ix), h
     ld h_stat(ix), #is_up

     ld  hl,   #crouch_status
     ld  (hl),  #0

    ret

  go_crouch:
    ld hl, #_pj_crouched
    ld h_w(ix), #6
    ld h_h(ix), #15
    ld a, h_y(ix)
     add #6
     ld h_y(ix), a
    ld h_stat(ix), #is_crouched 

    ld h_sp_l(ix), l
    ld h_sp_h(ix), h

    ld a, h_dir(ix)
    cp #1
    jr z, no
    call flip_sprite
    no:
    ld  hl,   #crouch_status
    ld  (hl),  #0


  ret
