;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "entity.h.s"
.include "menu.h.s"
.include "hero.h.s"
.include "levels.h.s"
.include "enemy.h.s"
.include "buffer.h.s"


m_num_obs_01: .db #5
m_num_obs_02: .db #3
m_num_obs_03: .db #4
m_num_obs_04: .db #7
m_num_obs_05: .db #7
m_num_obs_1: .db #11
m_num_obs_2: .db #8
m_num_obs_3: .db #10
m_num_obs_4: .db #12
m_num_obs_5: .db #9
m_num_obs_6: .db #10
m_num_obs_7: .db #10
m_num_obs_8: .db #11
m_num_obs_9: .db #10
m_num_obs_10: .db #10
m_num_obs_11: .db #12
m_num_obs_12: .db #12
m_num_obs_13: .db #11
m_num_obs_14: .db #11
m_num_obs_15: .db #15

floor_level_01:
DefineObstacle floor_0_01,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle roofL_1_01, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor21_1_01,  #00, #146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_1_01,  #00, #96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_1_01,  #00, #46,  #80,#08, #0, #0, _floor8

floor_level_02:
DefineObstacle floor_0_02,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle roofL_1_02, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor21_1_02,  #00, #146,  #80,#08, #0, #0, _floor8

floor_level_03:
DefineObstacle floor_0_03,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle roofL_1_03, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor21_1_03,  #00, #146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_1_03,  #00, #96,  #80,#08, #0, #0, _floor8

floor_level_04:
DefineObstacle floor_0_04,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle roofL_1_04, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor21_1_04,  #00, #146,  #38,#08, #-1, #0, _floor8not
DefineObstacle floor22_1_04,  #36,#146, #44,#08, #0, #0, _floor8
DefineObstacle floor31_1_04,  #00, #96,  #38,#08, #-1, #0, _floor8not
DefineObstacle floor32_1_04,  #36,#96, #44,#08, #0, #0, _floor8
DefineObstacle floor41_1_04,  #00, #46,  #80,#08, #0, #0, _floor8

floor_level_05:
DefineObstacle floor_0_05,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle roofL_1_05, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor21_1_05,  #00, #146,  #40,#08, #0, #0, _floor8
DefineObstacle floor22_1_05,  #60,#146, #20,#08, #-1, #0, _floor8not
DefineObstacle floor31_1_05,  #00, #96,  #38,#08, #0, #0, _floor8
DefineObstacle floor32_1_05,  #38,#96, #42,#08, #0, #0, _floor8
DefineObstacle floor41_1_05,  #00, #46,  #40,#08, #0, #0, _floor8

floor_level_1:
DefineObstacle floor_0_1,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor3_0_1,  #00,#96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_1,  #00,#46,  #20,#08, #0, #0, _floor8
DefineObstacle floor42_1,  #20,#46,  #60,#08, #-1, #0, _floor8not
DefineObstacle roofL_0_1, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor_1_1,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor21_1_1,  #00, #146,  #80,#08, #0, #1, _floor8
DefineObstacle floor31_1_1,  #00,#96,  #60,#08, #-1, #1, _floor8not
DefineObstacle floor32_1_1,  #60,#96,  #20,#08, #0, #1, _floor8
DefineObstacle floor41_1_1,  #00,#46,  #80,#08, #-1, #1, _floor8not
DefineObstacle roofL_1_1, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_2:
DefineObstacle floor_0_2,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor3_0_2,  #00,#96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_1_2,  #00, #46,  #20,#08, #0, #0, _floor8
DefineObstacle roofL_0_2, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor_1_2,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor21_1_2,  #60, #146,  #20,#08, #0, #1, _floor8
DefineObstacle floor3_1_2,  #00,#96,  #80,#08, #0, #1, _floor8
DefineObstacle roofL_1_2, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_3:
DefineObstacle floor_3,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_3,  #00, #146,  #80, #08,  #0, #0, _floor8
DefineObstacle floor31_3,  #00, #96,  #80, #08,  #-1, #0, _floor8not
DefineObstacle floor41_3,  #00, #46,  #80, #08,  #0, #0, _floor8
DefineObstacle roofL_3, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor11_3,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_3,  #60, #146,  #20, #08,  #0, #1, _floor8
DefineObstacle floor1_31_3,  #00, #96,  #80, #08,  #0, #1, _floor8
DefineObstacle floor1_41_3,  #00, #46,  #80, #08,  #0, #1, _floor8
DefineObstacle roofL_1_3, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_4:
DefineObstacle floor0_4,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_4,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_4,  #00,#96,  #40,#08, #0, #0, _floor8
DefineObstacle floor32_4,  #40,#96,  #40,#08, #-1, #0, _floor8not
DefineObstacle floor41_4,  #00,#46,  #80,#08, #0, #0, _floor8
DefineObstacle roofL_4, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor0_1_4,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_4,  #00,#146,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_31_4,  #00,#96,  #40,#08, #-1, #1, _floor8not
DefineObstacle floor1_32_4,  #40,#96,  #40,#08, #0, #1, _floor8
DefineObstacle floor1_41_4,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_4, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_5:
DefineObstacle floor0_5,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_5,  #00, #46,  #80, #08, #0, #0, _floor8
DefineObstacle floor3_5,  #40, #96,  #40, #08, #0, #0, _floor8
DefineObstacle floor4_5,  #40, #146,  #40, #08, #0, #0, _floor8
DefineObstacle roofL_5, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor1_0_5,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_5,  #00, #146,  #80, #08, #0, #1, _floor8
DefineObstacle floor1_3_5,  #00, #96,  #80, #08, #0, #1, _floor8
DefineObstacle roofL1_5, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_6:
DefineObstacle floor0_6,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_6,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_6,  #00,#96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_6,  #00,#46,  #80,#08, #-1, #0, _floor8not
DefineObstacle roofL_6, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor0_1_6,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_6,  #00,#146,  #80,#08, #-1, #1, _floor8not
DefineObstacle floor1_31_6,  #00,#96,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_41_6,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_6, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_7:
DefineObstacle floor0_7,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_7,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_7,  #00,#96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_7,  #00,#46,  #40,#08, #0, #0, _floor8
DefineObstacle roofL_7, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor0_1_7,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_22_7,  #40,#146,  #40,#08, #0, #1, _floor8
DefineObstacle floor1_31_7,  #00,#96,  #80,#08, #-1, #1, _floor8not
DefineObstacle floor1_41_7,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_7, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_8:
DefineObstacle floor0_8,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_8,  #00,#146,  #40,#08, #-1, #0, _floor8not
DefineObstacle floor22_8,  #40,#146,  #40,#08, #0, #0, _floor8
DefineObstacle floor31_8,  #00,#96,  #40,#08, #0, #0, _floor8
DefineObstacle floor41_8,  #00,#46,  #40,#08, #0, #0, _floor8
DefineObstacle roofL_8, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor0_1_8,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_8,  #00,#146,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_31_8,  #00,#96,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_41_8,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_8, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_9:
DefineObstacle floor0_9,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_9,  #00,#146,  #80,#08, #-1, #0, _floor8not
DefineObstacle floor31_9,  #00,#96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_9,  #00,#46,  #80,#08, #0, #0, _floor8
DefineObstacle roofL_9, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor1_0_9,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_9,  #00,#146,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_31_9,  #00,#96,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_41_9,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_9, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_10:
DefineObstacle floor0_10,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_10,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor32_10,  #40,#96,  #40,#08, #0, #0, _floor8
DefineObstacle floor41_10,  #00,#46,  #80,#08, #0, #0, _floor8
DefineObstacle roofL_10, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor1_0_10,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_10,  #00,#146,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_31_10,  #00,#96,  #40,#08, #0, #1, _floor8
DefineObstacle floor1_41_10,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_10, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_11:
DefineObstacle floor0_11,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_11,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor32_11,  #38,#96,  #42,#08, #0, #0, _floor8
DefineObstacle floor41_11,  #00,#46,  #40,#08, #0, #0, _floor8
DefineObstacle floor42_11,  #40,#46,  #16,#08, #0, #0, _floor8
DefineObstacle roofL_11, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor1_0_11,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_11,  #00,#146,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_31_11,  #00,#96,  #40,#08, #-1, #1, _floor8not
DefineObstacle floor1_32_11,  #60,#96,  #20,#08, #0, #1, _floor8
DefineObstacle floor1_41_11,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_11, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_12:
DefineObstacle floor0_12,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_12,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_12,  #00,#96,  #20,#08, #0, #0, _floor8
DefineObstacle floor32_12,  #40,#96,  #40,#08, #-1, #0, _floor8not
DefineObstacle floor41_12,  #00,#46,  #80,#08, #0, #0, _floor8
DefineObstacle roofL_12, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor1_0_12,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_12,  #00,#146,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_31_12,  #00,#96,  #40,#08, #-1, #1, _floor8not
DefineObstacle floor1_32_12,  #60,#96,  #20,#08, #0, #1, _floor8
DefineObstacle floor1_41_12,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_12, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_13:
DefineObstacle floor0_13,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_13,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_13,  #00,#96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_13,  #00,#46,  #80,#08, #0, #0, _floor8
DefineObstacle roofL_13, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor1_0_13,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_13,  #00,#146,  #16,#08, #0, #1, _floor8
DefineObstacle floor1_22_13,  #40,#146,  #40,#08, #-1, #1, _floor8not
DefineObstacle floor1_31_13,  #00,#96,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_41_13,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_13, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_14:
DefineObstacle floor0_14,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_14,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_14,  #00,#96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_14,  #00,#46,  #40,#08, #0, #0, _floor8
DefineObstacle roofL_14, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor1_0_14,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_22_14,  #40,#146,  #40,#08, #0, #1, _floor8
DefineObstacle floor1_21_14,  #00,#146,  #12,#08, #0, #1, _floor8
DefineObstacle floor1_31_14,  #00,#96,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_41_14,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_14, #00, #00,  #80, #04, #-1, #1, _roof

floor_level_15:
DefineObstacle floor0_15,  #00,#196,  #80,#04, #-1, #0, _floor4
DefineObstacle floor21_15,  #00,#146,  #80,#08, #0, #0, _floor8
DefineObstacle floor31_15,  #00,#96,  #80,#08, #0, #0, _floor8
DefineObstacle floor41_15,  #00,#46,  #80,#08, #0, #0, _floor8
DefineObstacle roofL_15, #00, #00,  #80, #04, #-1, #0, _roof
DefineObstacle floor1_0_15,  #00,#196,  #80,#04, #-1, #1, _floor4
DefineObstacle floor1_21_15,  #00,#146,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_31_15,  #00,#96,  #80,#08, #0, #1, _floor8
DefineObstacle floor1_41_15,  #00,#46,  #80,#08, #0, #1, _floor8
DefineObstacle roofL1_15, #00, #00,  #80, #04, #-1, #1, _roof
DefineObstacle floor2_15,  #00,#196,  #80,#04, #-1, #2, _floor4
DefineObstacle roofL2_15, #00, #00,  #80, #04, #-1, #2, _roof
DefineObstacle floor2_21_15,  #00,#146,  #80,#08, #0, #2, _floor8
DefineObstacle floor2_31_15,  #00,#96,  #80,#08, #0, #2, _floor8
DefineObstacle floor2_41_15,  #00,#46,  #80,#08, #0, #2, _floor8

;; #############################
;; # WALLS
;; #############################

;; NUMBERS

m_num_wall_01: .db #6
m_num_wall_02: .db #4
m_num_wall_03: .db #5
m_num_wall_04: .db #6
m_num_wall_05: .db #5
m_num_wall_1: .db #6
m_num_wall_2: .db #4
m_num_wall_3: .db #5
m_num_wall_4: .db #6
m_num_wall_5: .db #5
m_num_wall_6: .db #6
m_num_wall_7: .db #4
m_num_wall_8: .db #6
m_num_wall_9: .db #5
m_num_wall_10: .db #6
m_num_wall_11: .db #7
m_num_wall_12: .db #6
m_num_wall_13: .db #11
m_num_wall_14: .db #10
m_num_wall_15: .db #14

wall_level_01:
DefineWall leftWallH_0_01, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_0_01,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_1_01, #78, #0,   #02,#100, #0,_rightWall
DefineWall rightWallL_1_01,  #78,#99,   #02,#100, #0,_rightWall
DefineWall wall_1_01,  #38, #54,   #04,#92, #0,_middleWall
DefineWall wall1_1_01,  #38, #154,   #04,#44, #0,_middleWall

wall_level_02:
DefineWall leftWallH_0_02, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_0_02,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_1_02, #78, #0,   #02,#100, #0,_rightWall
DefineWall rightWallL_1_02,  #78,#99,   #02,#100, #0,_rightWall

wall_level_03:
DefineWall leftWallH_0_03, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_0_03,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_1_03, #78, #0,   #02,#100, #0,_rightWall
DefineWall rightWallL_1_03,  #78,#99,   #02,#100, #0,_rightWall
DefineWall wall1_1_03,  #38, #103,   #04,#44, #0,_middleWall

wall_level_04:
DefineWall leftWallH_0_04, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_0_04,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_1_04, #78, #0,   #02,#100, #0,_rightWall
DefineWall rightWallL_1_04,  #78,#99,   #02,#100, #0,_rightWall
DefineWall wall1_1_04,  #38, #100,   #04, #52, #0,_middleWall
DefineWall wall2_1_04,  #38, #04,   #04,#44, #0,_middleWall

wall_level_05:
DefineWall leftWallH_0_05, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_0_05,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_1_05, #78, #0,   #02,#100, #0,_rightWall
DefineWall rightWallL_1_05,  #78,#99,   #02,#100, #0,_rightWall
DefineWall wall_1_05,  #36, #48,   #04,#100, #0,_middleWall

wall_level_1:
DefineWall wall_1_1,  #33, #153,   #04,#44, #1, _middleWall
DefineWall wall1_1_1,  #55, #103,   #04,#44, #1, _middleWall
DefineWall leftWallH_0_1, #0, #0,   #02,#100, #0, _leftWall
DefineWall leftWallL_0_1,  #0,#99,   #02,#100, #0, _leftWall
DefineWall rightWallH_1_1, #78, #0,   #02,#100, #1,_rightWall
DefineWall rightWallL_1_1,  #78,#99,   #02,#100, #1,_rightWall

wall_level_2:
DefineWall leftWallH_2, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_2,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_1_2, #78, #0,   #02,#100, #1,_rightWall
DefineWall rightWallL_1_2,  #78,#99,   #02,#100, #1,_rightWall

wall_level_3:
DefineWall leftWallH_3, #0, #0,   #02, #100, #0,_leftWall
DefineWall leftWallL_3,  #0,#99,   #02, #100, #0,_leftWall
DefineWall wall_3,  #40, #3, #04, #44,  #0,_middleWall
DefineWall rightWallH_3, #78, #0,   #02, #100, #1,_rightWall
DefineWall eightWallL_3,  #78,#99,   #02, #100, #1,_rightWall

wall_level_4:
DefineWall leftWallH_4, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_4,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_4, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_4,  #78,#99,   #02,#100, #1,_rightWall
DefineWall wall1_4,  #36, #103, #04, #44,  #0,_middleWall
DefineWall wall2_4,  #40, #103, #04, #44,  #1,_middleWall

wall_level_5:
DefineWall leftWallH_5, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_5,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_5, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_5,  #78,#99,   #02,#100, #1,_rightWall
DefineWall wall1_5,  #40, #103, #04, #44,  #0,_middleWall

wall_level_6:
DefineWall leftWallH_6, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_6,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_6, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_6,  #78,#99,   #02,#100, #1,_rightWall
DefineWall wall1_6,  #40, #104, #04, #92,  #0,_middleWall
DefineWall wall2_6,  #40, #04, #04, #92,  #1,_middleWall

wall_level_7:
DefineWall leftWallH_7, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_7,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_7, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_7,  #78,#99,   #02,#100, #1,_rightWall

wall_level_8:
DefineWall leftWallH_8, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_8,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_8, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_8,  #78,#99,   #02,#100, #1,_rightWall
DefineWall wall1_8,  #40, #53, #04, #44,  #1,_middleWall
DefineWall wall2_8,  #40, #153, #04, #44,  #1,_middleWall

wall_level_9:
DefineWall leftWallH_9, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_9,  #0,#99,   #02,#100, #0,_leftWall
DefineWall rightWallH_9, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_9,  #78,#99,   #02,#100, #1,_rightWall
DefineWall wall1_9,  #40, #104, #04, #92,  #1,_middleWall

wall_level_10:
DefineWall leftWallH_10, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_10,  #0,#99,   #02,#100, #0,_leftWall
DefineWall wall1_10,  #78, #153,   #02,#44, #0,_rightWall
DefineWall wall2_10,  #0, #153,   #02,#44, #1,_leftWall
DefineWall rightWallH_10, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_10,  #78,#99,   #02,#100, #1,_rightWall

wall_level_11:
DefineWall leftWallH_11, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_11,  #0,#99,   #02,#100, #0,_leftWall
DefineWall wall1_11,  #78, #104,   #02,#92, #0,_rightWall
DefineWall wall3_11,  #38, #53,   #04,#44, #0,_middleWall
DefineWall wall2_11,  #0, #104,   #02,#92, #1,_leftWall
DefineWall rightWallH_11, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_11,  #78,#99,   #02,#100, #1,_rightWall

wall_level_12:
DefineWall leftWallH_12, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_12,  #0,#99,   #02,#100, #0,_leftWall
DefineWall wall1_12,  #78, #53,   #02,#144, #0,_rightWall
DefineWall wall2_12,  #0, #53,   #02,#144, #1,_leftWall
DefineWall rightWallH_12, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_12,  #78,#99,   #02,#100, #1,_rightWall

wall_level_13:
DefineWall leftWallH_13, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_13,  #0,#99,   #02,#100, #0,_leftWall
DefineWall wall1_13,  #37, #04,   #04,#92, #0,_middleWall
DefineWall wall2_13,  #78, #04,   #02,#92, #0,_rightWall
DefineWall wall3_13,  #78, #153,   #02,#44, #0,_rightWall
DefineWall wall4_13,  #38, #03,   #04,#44, #1,_middleWall
DefineWall wall5_13,  #0, #04,   #02,#92, #1,_leftWall
DefineWall wall6_13,  #0, #153,   #02,#44, #1,_leftWall
DefineWall wall7_13,  #40, #153,   #04,#44, #1,_middleWall
DefineWall rightWallH_13, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_13,  #78,#99,   #02,#100, #1,_rightWall

wall_level_14:
DefineWall leftWallH_14, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_14,  #0,#99,   #02,#100, #0,_leftWall
DefineWall wall1_14,  #36, #53,   #04,#44, #0,_middleWall
DefineWall wall2_14,  #78, #04,   #02,#92, #0,_rightWall
DefineWall wall3_14,  #78, #153,   #02,#44, #0,_rightWall
DefineWall wall4_14,  #38, #53,   #04,#44, #1,_middleWall
DefineWall wall5_14,  #0, #04,   #02,#92, #1,_leftWall
DefineWall rightWallH_14, #78, #0,   #02,#100, #1,_rightWall
DefineWall eightWallL_14,  #78,#99,   #02,#100, #1,_rightWall
DefineWall wall6_14,  #0, #153,   #02,#44, #1,_leftWall

wall_level_15:
DefineWall leftWallH_15, #0, #0,   #02,#100, #0,_leftWall
DefineWall leftWallL_15,  #0,#99,   #02,#100, #0,_leftWall
DefineWall wall1_15,  #37, #04,   #04,#92, #0,_middleWall
DefineWall wall2_15,  #78, #04,   #02,#92, #0,_rightWall
DefineWall wall3_15,  #78, #153,   #02,#44, #0,_rightWall
DefineWall wall4_15,  #37, #04,   #04,#92, #1,_middleWall
DefineWall wall5_15,  #0, #04,   #02,#92, #1,_leftWall
DefineWall wall6_15,  #0, #153,   #02,#44, #1,_leftWall
DefineWall rightWallH_15, #78, #0,   #02,#100, #1,_rightWall
DefineWall rightWallL_15,  #78,#148,   #02,#52, #1,_rightWall
DefineWall wall7_15,  #0, #04,   #02,#92, #2,_leftWall
DefineWall wall8_15,  #0, #153,   #02,#44, #2,_leftWall
DefineWall rightWallH2_15, #78, #0,   #02,#100, #2,_rightWall
DefineWall rightWallL2_15,  #78,#99,   #02,#100, #2,_rightWall

;; #############################
;; # DOORS
;; #############################

door_level01:
DefineDrawableEntity door01,  #67, #173, #8, #23, #_closed_door, #0

door_level02:
DefineDrawableEntity door02,  #67, #123, #8, #23, #_closed_door, #0

door_level03:
DefineDrawableEntity door03,  #67, #73, #8, #23, #_closed_door, #0

door_level04:
DefineDrawableEntity door04,  #67, #23, #8, #23, #_closed_door, #0

door_level05:
DefineDrawableEntity door05,  #67, #73, #8, #23, #_closed_door, #0

door_level1:
DefineDrawableEntity door1,  #67, #23, #8, #23, #_closed_door, #1

door_level2:
DefineDrawableEntity door2,  #7, #23, #8, #23,#_closed_door #0

door_level3:
DefineDrawableEntity door3,  #67, #73, #8, #23, #_closed_door, #1

door_level4:
DefineDrawableEntity door4,  #67, #23, #8, #23, #_closed_door, #1

door_level5:
DefineDrawableEntity door5,  #7, #23, #8, #23, #_closed_door, #0

door_level6:
DefineDrawableEntity door6,  #7, #23, #8, #23, #_closed_door, #0

door_level7:
DefineDrawableEntity door7,  #67, #73, #8, #23,#_closed_door, #1

door_level8:
DefineDrawableEntity door8,  #67, #73, #8, #23, #_closed_door, #1

door_level9:
DefineDrawableEntity door9,  #7, #73, #8, #23, #_closed_door, #0

door_level10:
DefineDrawableEntity door10,  #27, #73, #8, #23, #_closed_door, #1

door_level11:
DefineDrawableEntity door11,  #7, #123, #8, #23, #_closed_door, #0

door_level12:
DefineDrawableEntity door12,  #67, #73, #8, #23, #_closed_door, #1

door_level13:
DefineDrawableEntity door13,  #7, #173, #8, #23, #_closed_door, #1

door_level14:
DefineDrawableEntity door14,  #67, #173, #8, #23, #_closed_door, #1

door_level15:
DefineDrawableEntity door15,  #67, #23, #8, #23, #_closed_door, #0

;; #############################
;; # OBJECTS
;; #############################

m_num_obj_01: .db #0
m_num_obj_02: .db #0
m_num_obj_03: .db #1
m_num_obj_04: .db #1
m_num_obj_05: .db #0
m_num_obj_1: .db #2
m_num_obj_2: .db #1
m_num_obj_3: .db #3
m_num_obj_4: .db #0
m_num_obj_5: .db #3
m_num_obj_6: .db #1
m_num_obj_7: .db #1
m_num_obj_8: .db #3
m_num_obj_9: .db #1
m_num_obj_10: .db #1
m_num_obj_11: .db #2
m_num_obj_12: .db #2
m_num_obj_13: .db #2
m_num_obj_14: .db #3
m_num_obj_15: .db #7


;; Hearts Type = 1, Shield Typer = 0, Ammo Type = 2
object_level_01:

object_level_02:

object_level_03:
DefineObject shield_02, 50, 186, 6, 10, _shield,  0, 0, 1

object_level_04:
DefineObject life_04, 50, 86, 6, 10, _full_heart,  1, 0, 1

object_level_05:

object_level_1:
DefineObject shield_object1, 10, 136, 6, 10, _shield,  0, 1, 1
DefineObject life_1, 50, 86, 6, 10, _full_heart,  1, 0, 1

object_level_2:
DefineObject life_2, 70, 136, 6, 10, _full_heart,  1, 1, 1

object_level_3:
DefineObject bullets_3, 20, 136, 6, 10, _bullet_box,  2, 0, 1
DefineObject shield_object3, 10, 86, 6, 10, _shield,  0, 0, 1
DefineObject life_3, 60, 136, 6, 10, _full_heart,  1, 1, 1

object_level_4:

object_level_5:
DefineObject shield_object_5, 30, 36, 6, 10, _shield,  0, 0, 1
DefineObject bullets_5, 30, 186, 6, 10, _bullet_box,  2, 1, 1
DefineObject life_5, 60, 136, 6, 10, _full_heart,  1, 0, 1

object_level_6:
DefineObject bullets_6, 10, 136, 6, 10, _bullet_box,  2, 1, 1

object_level_7:
DefineObject shield_object7, 10, 36, 6, 10, _shield,  0, 0, 1

object_level_8:
DefineObject shield_object8, 10, 86, 6, 10, _shield,  0, 0, 1
DefineObject shield_object2_8, 30, 136, 6, 10, _shield,  0, 1, 1
DefineObject life_8, 20, 136, 6, 10, _full_heart,  1, 0, 1

object_level_9:
DefineObject bullets_9, 60, 136, 6, 10, _bullet_box,  2, 1, 1

object_level_10:
DefineObject bullets_10, 40, 186, 6, 10, _bullet_box,  2, 1, 1

object_level_11:
DefineObject shield_object11, 10, 86, 6, 10, _shield,  0, 1, 1
DefineObject life_11, 30, 36, 6, 10, _full_heart,  1, 0, 1

object_level_12:
DefineObject life_12, 10, 186, 6, 10, _full_heart,  1, 0, 1
DefineObject shield_object2_12, 10, 86, 6, 10, _shield,  0, 0, 1

object_level_13:
DefineObject shield_object_13, 10, 136, 6, 10, _shield,  0, 0, 1
DefineObject bullets_13, 60, 136, 6, 10, _bullet_box,  2, 1, 1

object_level_14:
DefineObject life_14, 50, 186, 6, 10, _full_heart,  1, 0, 1
DefineObject bullets_14, 60, 36, 6, 10, _bullet_box,  2, 1, 1
DefineObject bullets2_14, 60, 136, 6, 10, _bullet_box,  2, 1, 1

object_level_15:
DefineObject shield_object_15, 50, 186, 6, 10, _shield,  0, 0, 1
DefineObject bullets_15, 30, 136, 6, 10, _bullet_box,  2, 1, 1
DefineObject life_15, 50, 186, 6, 10, _full_heart,  1, 1, 1
DefineObject bullets2_15, 20, 36, 6, 10, _bullet_box,  2, 2, 1
DefineObject bullets3_15, 60, 86, 6, 10, _bullet_box,  2, 2, 1
DefineObject life2_15, 60, 136, 6, 10, _full_heart,  1, 2, 1
DefineObject life3A_15, 20, 186, 6, 10, _full_heart,  1, 2, 1


obstacle_vector:: .dw #floor_level_01
wall_vector:: .dw #wall_level_01
door_vector:: .dw #door_level01
object_vector:: .dw #object_level_01

m_num_obs:: .db #5					;; Number of Floors
m_num_wall:: .db #6                  ;; Number of Walls
m_num_object:: .db #0                ;; Number of object

actual_level:: .db #1


actual_obs: .dw #m_num_obs_01
actual_wall: .dw #m_num_wall_01
actual_obj: .dw #m_num_obj_01

restart_actual_level::
	ld a, (actual_level)
	ld b, a
	push bc 
	call restart_levels 
	call restart_enemies
	; call restart_objects
	pop bc
	next:
		ld a, (actual_level)
		cp b
		jr z, finish_restart
		push bc
		call find_next_obstacles
		call next_level_enemies
		; call next_object
		pop bc
		jr next
	finish_restart:

	ret 


restart_levels::
	ld 	hl, #floor_level_01
	ld (obstacle_vector), hl

	ld hl, #wall_level_01
	ld (wall_vector), hl

	ld hl, #door_level01
	ld (door_vector), hl

	ld a, #5
	ld (m_num_obs), a

	ld a, #6
	ld (m_num_wall), a

	ld 	hl, #m_num_obs_01
	ld (actual_obs), hl

	ld hl, #m_num_wall_01
	ld (actual_wall), hl

	call restart_objects

  ld a, #1
  ld (actual_level), a

	ret

restart_objects:
	ld a, #0
	ld (m_num_object), a
	ld hl, #m_num_obj_01 
	ld (actual_obj), hl
	ld hl, #object_level_01
	ld (object_vector), hl

	ld  a, (m_num_levels)
	ld  e, a

	restart_obj_levels:
	ld  a, (m_num_object)
	ld  ix, (object_vector)
	cp #0
	jr z, call_next_object

	restart_buc_obj:
    ld d, #1
    ld o_status(ix), d
	push af
	ld a, o_type(ix)
	;; Hearts Type = 1, Shield Typer = 0, Ammo Type = 2
	cp #0
	jr z, shieldObj 
	cp #1
	jr z, heartObj
	ld hl, #_bullet_box
	jr finishSprite

	shieldObj:
	ld hl, #_shield
	jr finishSprite

	heartObj:
	ld hl, #_full_heart

	finishSprite:
	call change_sprite

	pop af

    ld  bc, #k_obj_size      ;;|
    add   ix,   bc             ;;\ Sumar al puntero el tamaño de la entidad
    dec   a
    jr    nz,   restart_buc_obj
	
	call_next_object:
    call next_object

    dec e
    jr  nz, restart_obj_levels

	ld a, #0
	ld (m_num_object), a
	ld hl, #object_level_01
	ld (object_vector), hl
	ld hl, #m_num_obj_01
	ld (actual_obj), hl
	ret


find_next_obstacles:
	ld hl, (obstacle_vector)
	ld a, (m_num_obs)
	ld bc, #k_obs_size

	buc_obs_next:
		cp #0
		jr z, obs_done

		add hl, bc
		dec a

		jr buc_obs_next

	obs_done:
		ld 	(obstacle_vector), hl
		ld 	hl, (actual_obs)
		ld 	bc,	#0x0001
		add hl, bc
		ld 	a, (hl)
		ld 	(m_num_obs), a
		ld 	(actual_obs), hl

	ld hl, (wall_vector)
	ld a, (m_num_wall)
	ld bc, #k_wall_size

	buc_wall_next:
		cp #0
		jr z, wall_done

		add hl, bc
		dec a

		jr buc_wall_next

	wall_done:
		ld 	(wall_vector), hl
		ld 	hl, (actual_wall)
		ld 	bc,	#0x0001
		add hl, bc
		ld 	a, (hl)
		ld 	(m_num_wall), a
		ld 	(actual_wall), hl

	ld hl, (door_vector)
	ld a, #1
	ld bc, #k_door_size

	buc_door_next:
		cp #0
		jr z, door_done

		add hl, bc
		dec a

		jr buc_door_next

	door_done:
		ld 	(door_vector), hl


	call next_object

	ld a, (actual_level)
	inc a
	ld (actual_level), a

	ret

next_object:
	ld hl, (object_vector)
	ld a, (m_num_object)
	ld bc, #k_obj_size

	buc_obj_next:
		cp #0
		jr z, obj_done

		add hl, bc
		dec a

		jr buc_obj_next

	obj_done:
		ld 	(object_vector), hl
		ld 	hl, (actual_obj)
		ld 	bc,	#0x0001
		add hl, bc
		ld 	a, (hl)
		ld 	(m_num_object), a
		ld 	(actual_obj), hl
	ret

next_level::
	call find_next_obstacles

	call clearBuffer
	call switchBuffers
	call clearBuffer
	call switchBuffers

	call init_obstacles
	call init_objects
	call next_level_enemies

jp hero_main



