;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "menu.h.s"
.include "utils.h.s"
.include "cpctelera.h.s"
.include "entity.h.s"
.include "weapon.h.s"
.include "hero.h.s"
.include "enemy.h.s"
.include "bullet.h.s"
.include "buffer.h.s"
.include "object.h.s"
.include "levels.h.s"




;; Start of _DATA area 
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
;;
.area _DATA
;;
;; Start of _CODE area
;; 


.area _CODE
handler: .db #5
isr::
  ex af, af'
  exx
  push af
  push iy 
  push hl 
  push bc 
  push de

  ld a, (handler)
  dec a
  ld (handler),a 
  jr nz, isr_return

  call cpct_akp_musicPlay_asm
  ld a, #5
  ld (handler),a

  isr_return:
  pop de 
  pop bc 
  pop hl 
  pop iy
  pop af
  exx
  ex af, af'
  ret



setup_main::
   call cpct_disableFirmware_asm

   ld c, #0
   call cpct_setVideoMode_asm
   ld hl, #_palette
   ld de, #16
   call cpct_setPalette_asm

  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; REALIZA UNA ESPERA DE  s
;; REGISTROS DESTRUIDOS: b
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

esperar::
    ld b, #0x1000
    bucle:
    halt
    dec b
    jr nz, bucle
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; REALIZA UNA ESPERA DE  s
;; REGISTROS DESTRUIDOS: b
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 pause_control::

  ld    hl, #Key_Esc                                ;; HL = Key ESC id
  call  cpct_isKeyPressed_asm                     ;; Check if ESC was pressed                                         
  jr    z, ESC_no_pulsada                           ;; Jump if ESC was not pressed

    ;; Key ESC Pressed

      call show_pause

      pause_loop:
        call  cpct_scanKeyboard_asm

        ld    hl, #Key_1                                ;; HL = Key 1 id
        call  cpct_isKeyPressed_asm                     ;; Check if 1 was pressed                                      
        jr    z, Key1_no_pulsada                           ; Jump if 1 was not pressed

          ;; Key 1 pressed
          ;call clearBuffer
          ;call clearFrontBuffer
          jp init_all

        ;; Key 1 NOT pressed
        Key1_no_pulsada:
          ld    hl, #Key_2                                ;; HL = Key 2 id
          call  cpct_isKeyPressed_asm                     ;; Check if 2 was pressed                                        
          jr    z, Key2_no_pulsada                           ; Jump if 2 was not pressed

            ;; Key 2 pressed
            ending_game:
            call esperar
            call reset_hero
            call restart_bullets
            call restart_levels
            call restart_enemies 


             jp beggining

        ;; Key 2 NOT pressed
        Key2_no_pulsada:
        jr pause_loop


            

  ;; Key ESC NOT pressed
  ESC_no_pulsada:
   jp loop
 

;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;
_main::
  ld sp, #0x8000  ;;Change stack position
  call setup_main
  beggining::
    ld de, #_song
  call cpct_akp_musicInit_asm
    ld hl, #isr 
  call cpct_setInterruptHandler_asm
  call mostrar_menu

init_all::

  call clearBuffer
  call switchBuffers
  call clearBuffer
  call switchBuffers
  
  call init_obstacles
  call init_objects
  loop:

    call hero_main
    jp pause_control 

    jr loop

