;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "menu.h.s"
.include "utils.h.s"
.include "cpctelera.h.s"
.include "hero.h.s"
.include "entity.h.s"
.include "levels.h.s"
.include "buffer.h.s"
.area _DATA


option:: .db #0         ;; 2- keyboard, 1-joystick
start:: .db #0          ;; start = 1 -> start game

DefineControlsUser keyboard #Key_A, #Key_D, #Key_W, #Key_S
DefineControlsUser joystick #Joy0_Left, #Joy0_Right, #Joy0_Up, #Joy0_Down

img_win_size = 0xA18
decompress_buffer_end2 = decompress_buffer + img_win_size - 1
.area _CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ELIGE LA OPCION DEL TECLADO SEGUN LA TECLA PULSADA
;; REGISTRO ENTRADA: 
;; REGISTRO SALIDA: 
;; REGISTRO DESTRUIDOS: HL, A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

show_win::

  ld de, #decompress_buffer_end2
  ld hl, #_win1_end
  call decompress_an_element
  ld b, #60
  ld c, #2
  call getPtr

  ld    b,    #68   
  ld    c,    #38 
  ld hl, #ptr
  call cpct_drawSprite_asm

  ld de, #decompress_buffer_end2 
  ld hl, #_win2_end
  call decompress_an_element
  ld b, #60
  ld c, #40
  call getPtr


  ld    b,    #68    
  ld    c,    #38 
  ld hl, #ptr
  call cpct_drawSprite_asm

  call esperar

ret

press_esc::

   call  cpct_scanKeyboard_asm

    ld    hl, #Key_Esc
    call  cpct_isKeyPressed_asm
    jr    z, esc_not_pressed
      ld a, #4
      ret
    esc_not_pressed:
    ld a, #5
    ret


choose_option::
  call  cpct_scanKeyboard_asm

    ld    hl, #Key_1
    call  cpct_isKeyPressed_asm
    jr    z, one2_not_pressed
    ld a, #1
    ret
    one2_not_pressed:

      ld    hl, #Key_2
    call  cpct_isKeyPressed_asm
    jr    z, two_not_pressed
      ld a, #2

    two_not_pressed:
    ret
   
elegirOpcion::
    call  cpct_scanKeyboard_asm
    ld    hl, #Key_1
    call  cpct_isKeyPressed_asm
    jr    z, one_not_pressed
        ld hl, #option
        ld (hl), #1
        jr continue
    one_not_pressed:
        ld    hl, #Key_2
        call  cpct_isKeyPressed_asm
        jr    z, menu_continue
            ld hl, #option
            ld (hl), #2

    continue:
    ld hl, #start 
    ld (hl), #1
    
    menu_continue:

    ret

decompress_buffer = 0x040 ;;Starts on 0x040


img_max_size = 0x1F40 ;;max_size of all our levels
decompress_buffer_end = decompress_buffer + img_max_size - 1
ptr =  decompress_buffer + 0 ; + Offset
img_min_size = 0x50A
decompress_buffer_end1 = decompress_buffer + img_min_size - 1

decompress_an_element::
 call cpct_zx7b_decrunch_s_asm
  ret
getPtr::
  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0
    call cpct_getScreenPtr_asm
      ex    de,   hl  
ret

show_pause::
  call clearBuffer

  ld de, #decompress_buffer_end1
  ld hl, #_pause1_end
  call decompress_an_element
    ld b, #60
  ld c, #10 
  call getPtr

  ld    b,    #43   
  ld    c,    #30 
  ld hl, #ptr
  call cpct_drawSprite_asm

  ld de, #decompress_buffer_end1 
  ld hl, #_pause2_end
  call decompress_an_element
  ld b, #60
  ld c, #40
  call getPtr


  ld    b,    #43    
  ld    c,    #30 
  ld hl, #ptr
  call cpct_drawSprite_asm


 ret

show_dead::
  ld de, #decompress_buffer_end 
  ld hl, #_dead1_end
  call decompress_an_element
  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0 
  ld    b, #0               ;; B = y coordinate (24 = 0x18)
  ld    c, #0                ;; C = x coordinate (16 = 0x10)
  call cpct_getScreenPtr_asm  

   ex    de,   hl 
   ld    b,    #200    
   ld    c,    #40 
   ld hl, #ptr
   call cpct_drawSprite_asm
  ld de, #decompress_buffer_end 
  ld hl, #_dead2_end
  call decompress_an_element

 ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0
  ld    b, #0               ;; B = y coordinate (24 = 0x18)
  ld    c, #40              ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  
   ex    de,   hl 
   ld    b,    #200    
   ld    c,    #40 
   ld hl, #ptr
   call cpct_drawSprite_asm

    ret
img_min_size1 = 0xBB8
decompress_buffer_end2 = decompress_buffer + img_min_size1 - 1
show_input::
  ld de, #decompress_buffer_end2 
  ld hl, #_input1_end
  call decompress_an_element
  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0 
  ld    b, #100               ;; B = y coordinate (24 = 0x18)
  ld    c, #0                ;; C = x coordinate (16 = 0x10)
  call cpct_getScreenPtr_asm  

   ex    de,   hl 
   ld    b,    #75    
   ld    c,    #40 
   ld hl, #ptr
   call cpct_drawSprite_asm



  ld de, #decompress_buffer_end2
  ld hl, #_input2_end
  call decompress_an_element

 ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0
  ld    b, #100               ;; B = y coordinate (24 = 0x18)
  ld    c, #40              ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  
   ex    de,   hl 
   ld    b,    #75    
   ld    c,    #40 
   ld hl, #ptr
   call cpct_drawSprite_asm
    ret

show_controls::

  ld de, #decompress_buffer_end2 
  ld hl, #_control1_end
  call decompress_an_element
  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0 
  ld    b, #100               ;; B = y coordinate (24 = 0x18)
  ld    c, #0                ;; C = x coordinate (16 = 0x10)
  call cpct_getScreenPtr_asm  

   ex    de,   hl 
   ld    b,    #75    
   ld    c,    #40 
   ld hl, #ptr
   call cpct_drawSprite_asm



  ld de, #decompress_buffer_end2
  ld hl, #_control2_end
  call decompress_an_element

 ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0
  ld    b, #100               ;; B = y coordinate (24 = 0x18)
  ld    c, #40              ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  
   ex    de,   hl 
   ld    b,    #75    
   ld    c,    #40 
   ld hl, #ptr
   call cpct_drawSprite_asm
    ret

; #############################
;; DECOMPRESSION LEVELS
;; #############################
show_menu::
  ld de, #decompress_buffer_end 
  ld hl, #_menu1_end
  call decompress_an_element

  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0
  ld b, #0
  ld c, #0 
  call cpct_getScreenPtr_asm  
   ex    de,   hl 
   ld    b,    #200    
   ld    c,    #40 
   ld hl, #ptr
   call cpct_drawSprite_asm

  ld de, #decompress_buffer_end 
  ld hl, #_menu2_end
  call decompress_an_element

  ld   a, (m_front_buffer) ;; DE = Pointer to start of the screen
  ld d, a
  ld e, #0;; DE = Pointer to start of the screen
  ld    b, #0               ;; B = y coordinate (24 = 0x18)
  ld    c, #40              ;; C = x coordinate (16 = 0x10)

  call cpct_getScreenPtr_asm  

   ex    de,   hl 
   ld    b,    #200    
   ld    c,    #40 
   ld hl, #ptr
   call cpct_drawSprite_asm

    ret




mostrar_menu::
  call show_menu
  loopeo:
   call choose_option
   cp #1
   jp z, mostrar_input
   cp #2
   jp z, mostrar_controls
   jp loopeo

  ret


mostrar_input::
  call esperar
  call show_input
  call esperar
  bucle:
  call elegirOpcion
  ld a, (start)
  cp #0
  jr z, bucle
  ld hl, #start
  ld (hl), #0

ret

mostrar_controls::
  call show_controls

    controls_buc:
    call press_esc

    cp #4
    jp nz, controls_buc 

jp mostrar_menu