;;-----------------------------LICENSE NOTICE------------------------------------
;; _________.__             .__                   __        .___    ___.    __   
;; \__    ___/|  |__   ____   |  | _____    _______/  |_    __| _/____\_ |___/  |_ 
;;   |    |   |  |  \_/ __ \  |  | \__  \  /  ___/\   __\  / __ |/ __ \| __ \   __\
;;   |    |   |   Y  \  ___/  |  |__/ __ \_\___ \  |  |   / /_/ \  ___/| \_\ \  |  
;;   |____|   |___|  /\___  > |____(____  /____  > |__|   \____ |\___  >___  /__|  
;;                 \/     \/            \/     \/              \/    \/    \/      
;;
;;  Code Copyright (C) 2018 RetroJAM Games (@RetroJamGames)
;;  This file is part of The Last Debt: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "weapon.h.s"
.include "cpctelera.h.s"
.include "utils.h.s"
.include "entity.h.s"
.include "hero.h.s"
.include "enemy.h.s"
.include "bullet.h.s"


;;================================
;; Changes the weapon of the hero
;; DESTROYS: HL, AF, 
;;===============================
change_weapon:
  call  cpct_scanKeyboard_asm
  ld    hl, #Key_X
  call  cpct_isKeyPressed_asm
  jr    z, X_not_pressed

  ld a, (changeW_status)                     ;; Load in A Crouch Status
  cp #0                                     ;; Compare A with 0
  jr  z,  X_not_pressed 

  ld ix, #hero
  ld a, h_wp(ix) ;; Current weapon
  cp #0 ;; If it's 0, he has a pistol
  
  jr z, change_into_sword 
  ld h_wp(ix), #0 ;;Change to pistol
  ld hl, #_pj
  call change_sprite 
  jp finish
  
  change_into_sword:
    ld h_wp(ix), #1 ;;Change to sword
    ld hl, #_pj_swstill
    call change_sprite 
  finish: 
  ld  hl,   #changeW_status
  ld  (hl),  #0
  X_not_pressed:
  ret
;;================================
;; Changes the weapon of the hero
;; DESTROYS: HL, AF, 
;;===============================

attack:
  call cpct_scanKeyboard_asm          ;; Scan Keyboard
  ld    hl,   #Key_Space                  ;;  HL = Key D id
  call cpct_isKeyPressed_asm          ;; Check if D was pressed
  cp    #0                            ;; Check if register A==0
  jr    z, Space_not_pressed 

  ld ix, #hero

  ld a, h_wp(ix) ;;If hero's has pistol --> shoots. Otherwise attacks with sword
  cp #0
  jr nz,attack_with_sword
    shoot:
      ld a, (shootHero_status)                     ;; Load in A Crouch Status
      cp #0
      jr z, Space_not_pressed

      ld hl, #_pj_shooting 
      call change_sprite
      call check_ammo ;; checks ammo and if it's >= shoots

  Space_not_pressed:
    finalizar:
    ret

;;================================
;; Attacks with sword and checks the collisions
;; DESTROYS: HL, AF, 
;;===============================
attack_with_sword:
  ld  a, h_dir(ix)
  cp #1
  jr  nz, left

    ld a, h_x(ix)
    add #3
    ld h_x(ix), a
    
    call check_enemy_collision_sword

    ld a, h_x(ix)
    sub #3
    ld h_x(ix), a

    jr continue_attack_sword


  left:

    ld a, h_x(ix)
    sub #3
    ld h_x(ix), a

    call check_enemy_collision_sword

    ld a, h_x(ix)
    add #3
    ld h_x(ix), a
  
  continue_attack_sword:
  ld hl, #_pj_swattack 
  call change_sprite
  ld a, #0 
  cp #0 
  ret
